//
//  main.m
//  DNP Printer Utility
//
//  Created by atomicpepper on 2/6/13.
//
//

#import <Cocoa/Cocoa.h>

static char * revStr()
{
    static char revStr[16]="";
    if(0 == revStr[0])
    {
        char * revPtr = SVN_REV_VALUE;
        int i,j;
        
        for(i=0;sizeof(SVN_REV_VALUE) > i && ' ' != revPtr[i++];);
        
        for(j=0;sizeof(SVN_REV_VALUE) > i && sizeof(revStr) - 1 > j && ' ' != revPtr[i];)
            revStr[j++] = revPtr[i++];
        
        if(0 == j)
        {
            revStr[j++]='!';
        }
        revStr[j]='\0';
        
    }
    
    return revStr;
}

int main(int argc, char *argv[])
{
    return NSApplicationMain(argc,  (const char **) argv);
}
const char *strForCFStreamStatus(CFStreamStatus streamStatus)
{
    //  return a char string for a CFStreamStatus
    switch(streamStatus)
    {
        case kCFStreamStatusNotOpen: return "kCFStreamStatusNotOpen";
        case kCFStreamStatusOpening: return "kCFStreamStatusOpening";
        case kCFStreamStatusOpen:    return "kCFStreamStatusOpen";
        case kCFStreamStatusReading: return "kCFStreamStatusReading";
        case kCFStreamStatusWriting: return "kCFStreamStatusWriting";
        case kCFStreamStatusAtEnd:   return "kCFStreamStatusAtEnd";
        case kCFStreamStatusClosed:  return "kCFStreamStatusClosed";
        case kCFStreamStatusError:   return "kCFStreamStatusError";
        default:    break;
    }
    return "kCFStreamStatusUnknown";
}
const char *strForCFEventType(CFStreamEventType eventType)
{
    //  return a char string for a CFStreamStatus
    switch(eventType)
    {
        case kCFStreamEventNone: return "kCFStreamEventNone";
        case kCFStreamEventOpenCompleted: return "kCFStreamEventOpenCompleted";
        case kCFStreamEventHasBytesAvailable: return "kCFStreamEventHasBytesAvailable";
        case kCFStreamEventCanAcceptBytes: return "kCFStreamEventCanAcceptBytes";
        case kCFStreamEventErrorOccurred: return "kCFStreamEventErrorOccurred";
        case kCFStreamEventEndEncountered: return "kCFStreamEventEndEncountered";
            
        default:    break;
    }
    return "kCFStreamEventUnknown";
}
const char *strForIOMessage(IOMessage message)
{
    //  return a char string for an IOReturn code
    switch(message)
    {
        case kIOMessageServiceIsTerminated      :    return "kIOMessageServiceIsTerminated";
        case kIOMessageServiceIsSuspended       :    return "kIOMessageServiceIsSuspended";
        case kIOMessageServiceIsResumed         :    return "kIOMessageServiceIsResumed";
        case kIOMessageServiceIsRequestingClose :    return "kIOMessageServiceIsRequestingClose";
        case kIOMessageServiceIsAttemptingOpen  :    return "kIOMessageServiceIsAttemptingOpen";
        case kIOMessageServiceWasClosed         :    return "kIOMessageServiceWasClosed";
        case kIOMessageServiceBusyStateChange   :    return "kIOMessageServiceBusyStateChange";
        case kIOMessageServicePropertyChange    :    return "kIOMessageServicePropertyChange";
        case kIOMessageCanDevicePowerOff        :    return "kIOMessageCanDevicePowerOff";
        case kIOMessageDeviceWillPowerOff       :    return "kIOMessageDeviceWillPowerOff";
        case kIOMessageDeviceWillNotPowerOff    :    return "kIOMessageDeviceWillNotPowerOff";
        case kIOMessageDeviceHasPoweredOn       :    return "kIOMessageDeviceHasPoweredOn";
        case kIOMessageCanSystemPowerOff        :    return "kIOMessageCanSystemPowerOff";
        case kIOMessageSystemWillPowerOff       :    return "kIOMessageSystemWillPowerOff";
        case kIOMessageSystemWillNotPowerOff    :    return "kIOMessageSystemWillNotPowerOff";
        case kIOMessageCanSystemSleep           :    return "kIOMessageCanSystemSleep";
        case kIOMessageSystemWillSleep          :    return "kIOMessageSystemWillSleep";
        case kIOMessageSystemWillNotSleep       :    return "kIOMessageSystemWillNotSleep";
        case kIOMessageSystemHasPoweredOn       :    return "kIOMessageSystemHasPoweredOn";
        case kIOMessageSystemWillRestart        :    return "kIOMessageSystemWillRestart";
        case kIOMessageSystemWillPowerOn        :    return "kIOMessageSystemWillPowerOn";
        case kIOMessageCopyClientID             :    return "kIOMessageCopyClientID";
            
        default                                 :    return "kIOMessageUnknown";
            break;
    }
}
const char *strForIOReturn(IOReturn ioResult)
{
    //  return a char string for an IOReturn code
    switch(ioResult)
    {
            // success (no error)
        case kIOReturnSuccess:          return "kIOReturnSuccess";
            
            // general IOKit returns
        case kIOReturnExclusiveAccess:  return "kIOReturnExclusiveAccess";
        case kIOReturnNoMemory:         return "kIOReturnNoMemory";
        case kIOReturnNotFound:         return "kIOReturnNotFound";
        case kIOReturnTimeout:          return "kIOReturnTimeout";
        case kIOReturnNoDevice:         return "kIOReturnNoDevice";
        case kIOReturnInvalid:          return "kIOReturnInvalid";
        case kIOReturnNoResources:      return "kIOReturnNoResources";
        case kIOReturnStillOpen:        return "kIOReturnStillOpen";
            
        case kIOReturnUnderrun:         return "kIOReturnUnderrun";
        case kIOReturnOverrun:          return "kIOReturnOverrun";
        case kIOReturnNotResponding:    return "kIOReturnNotResponding";
        case kIOReturnDeviceError:      return "kIOReturnDeviceError";
        case kIOReturnNoCompletion:     return "kIOReturnNoCompletion";
        case kIOReturnAborted:          return "kIOReturnAborted";
        case kIOReturnNoBandwidth:      return "kIOReturnNoBandwidth";
            
        case kIOReturnIPCError:         return "kIOReturnIPCError";
        case kIOReturnNotPrivileged:    return "kIOReturnNotPrivileged";
        case kIOReturnBadArgument:      return "kIOReturnBadArgument";
        case kIOReturnLockedRead:       return "kIOReturnLockedRead";
        case kIOReturnLockedWrite:      return "kIOReturnLockedWrite";
            
            // IOUSBFamily error returns
        case kIOUSBTransactionTimeout:  return "kIOUSBTransactionTimeout";
        case kIOUSBTransactionReturned: return "kIOUSBTransactionReturned";
        case kIOUSBPipeStalled:         return "kIOUSBPipeStalled";
        case kIOUSBTooManyPipesErr:     return "kIOUSBTooManyPipesErr";
        case kIOUSBNotEnoughPipesErr:   return "kIOUSBNotEnoughPipesErr";
        case kIOUSBUnknownPipeErr:      return "kIOUSBUnknownPipeErr";
        case kIOUSBNoAsyncPortErr:      return "kIOUSBNoAsyncPortErr";
        case kIOUSBEndpointNotFound:    return "kIOUSBEndpointNotFound";
        case kIOUSBInterfaceNotFound:   return "kIOUSBInterfaceNotFound";
        case kIOUSBConfigNotFound:      return "kIOUSBConfigNotFound";
        case kIOUSBNotEnoughPowerErr:   return "kIOUSBNotEnoughPowerErr";
        case kIOUSBHighSpeedSplitError: return "kIOUSBHighSpeedSplitError";
            
        case kIOUSBLowLatencyBufferNotPreviouslyAllocated:      return "kIOUSBLowLatencyBufferNotPreviouslyAllocated";
        case kIOUSBLowLatencyFrameListNotPreviouslyAllocated:   return "kIOUSBLowLatencyFrameListNotPreviouslyAllocated";
            
        case kIOUSBLinkErr:             return "kIOUSBLinkErr";
        case kIOUSBNotSent2Err:         return "kIOUSBNotSent2Err";
        case kIOUSBNotSent1Err:         return "kIOUSBNotSent1Err";
        case kIOUSBBufferUnderrunErr:   return "kIOUSBBufferUnderrunErr";
        case kIOUSBBufferOverrunErr:    return "kIOUSBBufferOverrunErr";
        case kIOUSBReserved2Err:        return "kIOUSBReserved2Err";
        case kIOUSBReserved1Err:        return "kIOUSBReserved1Err";
        case kIOUSBWrongPIDErr:         return "kIOUSBWrongPIDErr";
        case kIOUSBPIDCheckErr:         return "kIOUSBPIDCheckErr";
        case kIOUSBDataToggleErr:       return "kIOUSBDataToggleErr";
        case kIOUSBBitstufErr:          return "kIOUSBBitstufErr";
        case kIOUSBCRCErr:              return "kIOUSBCRCErr";
            
        default:                        return "kIOReturnError";
            break;
    }
}
const char *strForErrno(int err)
{
    //  return a char string for an signal code
    switch(err)
    {
        case EPERM  :    return "EPERM - Operation not permitted";
        case ENOENT  :    return "ENOENT - No such file or directory";
        case ESRCH  :    return "ESRCH - No such process";
        case EINTR  :    return "EINTR - Interrupted system call";
        case EIO  :    return "EIO - Input/output error";
        case ENXIO  :    return "ENXIO - Device not configured";
        case E2BIG  :    return "E2BIG - Argument list too long";
        case ENOEXEC  :    return "ENOEXEC - Exec format error";
        case EBADF  :    return "EBADF - Bad file descriptor";
        case ECHILD  :    return "ECHILD - No child processes";
        case EDEADLK  :    return "EDEADLK - Resource deadlock avoided";
        case ENOMEM  :    return "ENOMEM - Cannot allocate memory";
        case EACCES  :    return "EACCES - Permission denied";
        case EFAULT  :    return "EFAULT - Bad address";
#if !defined(_POSIX_C_SOURCE) || defined(_DARWIN_C_SOURCE)
        case ENOTBLK  :    return "ENOTBLK - Block device required";
#endif
        case EBUSY  :    return "EBUSY - Device / Resource busy";
        case EEXIST  :    return "EEXIST - File exists";
        case EXDEV  :    return "EXDEV - Cross-device link";
        case ENODEV  :    return "ENODEV - Operation not supported by device";
        case ENOTDIR  :    return "ENOTDIR - Not a directory";
        case EISDIR  :    return "EISDIR - Is a directory";
        case EINVAL  :    return "EINVAL - Invalid argument";
        case ENFILE  :    return "ENFILE - Too many open files in system";
        case EMFILE  :    return "EMFILE - Too many open files";
        case ENOTTY  :    return "ENOTTY - Inappropriate ioctl for device";
        case ETXTBSY  :    return "ETXTBSY - Text file busy";
        case EFBIG  :    return "EFBIG - File too large";
        case ENOSPC  :    return "ENOSPC - No space left on device";
        case ESPIPE  :    return "ESPIPE - Illegal seek";
        case EROFS  :    return "EROFS - Read-only file system";
        case EMLINK  :    return "EMLINK - Too many links";
        case EPIPE  :    return "EPIPE - Broken pipe";
        case EDOM  :    return "EDOM - Numerical argument out of domain";
        case ERANGE  :    return "ERANGE - Result too large";
        case EAGAIN  :    return "EAGAIN - Resource temporarily unavailable; Operation would block";
        case EINPROGRESS  :    return "EINPROGRESS - Operation now in progress";
        case EALREADY  :    return "EALREADY - Operation already in progress";
        case ENOTSOCK  :    return "ENOTSOCK - Socket operation on non-socket";
        case EDESTADDRREQ  :    return "EDESTADDRREQ - Destination address required";
        case EMSGSIZE  :    return "EMSGSIZE - Message too long";
        case EPROTOTYPE  :    return "EPROTOTYPE - Protocol wrong type for socket";
        case ENOPROTOOPT  :    return "ENOPROTOOPT - Protocol not available";
        case EPROTONOSUPPORT  :    return "EPROTONOSUPPORT - Protocol not supported";
            
        default:        return "unknown";
            break;
    }
}
const char *strForSignal(int sigraised)
{
    //  return a char string for an signal code
    switch(sigraised)
    {
        case SIGHUP  :    return "HangUP";
        case SIGINT  :    return "INTerrupt";
        case SIGQUIT :    return "QUIT";
        case SIGILL  :    return "ILLegal instruction";
        case SIGABRT :    return "ABoRT";
        case SIGTRAP :    return "trace TRAP";
            
        case SIGFPE  :    return "Floating Point Exception";
        case SIGKILL :    return "KILL";
        case SIGBUS  :    return "BUS error";
        case SIGSEGV :    return "SEGmentation Violation";
        case SIGSYS  :    return "bad argument to SYStem call";
        case SIGPIPE :    return "write on a PIPE with no one to read it";
        case SIGALRM :    return "ALaRM clock";
        case SIGTERM :    return "software TERMination signal from kill";
        case SIGURG  :    return "URGent condition on IO channel";
        case SIGSTOP :    return "sendable STOP signal not from tty";
        case SIGTSTP :    return "Tty SToP signal";
        case SIGCONT :    return "CONTinue a stopped process";
        case SIGCHLD :    return "to parent on CHiLD stop or exit";
        case SIGTTIN :    return "to readers pgrp upon background TTy read IN";
        case SIGTTOU :    return "like TTin for OUtput";
        case SIGXCPU :    return "eXceeded CPU time limit";
        case SIGXFSZ :    return "eXceeded File SiZe limit";
        case SIGVTALRM:   return "Virtual Time ALaRM";
        case SIGPROF :    return "PROFiling time alarm";
        case SIGUSR1 :    return "USeR 1";
        case SIGUSR2 :    return "USeR 2";
            
            
#if  (!defined(_POSIX_C_SOURCE) || defined(_DARWIN_C_SOURCE))
        case SIGIO      :    return "Input/Output possible signal";
        case SIGWINCH   :    return "WINdow size CHanges";
        case SIGINFO    :    return "INFOrmation request";
#endif
            
        default:        return "unknown";
            break;
    }
}
