/*
    PDE.h
	Copyright © 2000-2007 TriPrism Inc. All Rights Reserved.

 */

#import "ATMPPRBasePDE.h"
//#import "../filter/NoritsuNetOrder.h"

#define NORITSU_PDE_LOG_FOLDER "/var/log/noritsu/"
#define NORITSU_PDE_LOGFILE "NoritsuPDE"


#define TPPDE_BUNDLE_ID               	@"com.dnpphoto.dsclass.pde"

#define TPPDE_USER_DEFAULTS_ID_LAST_TOKEN       @"com.noritsu.print.pde.cvp.lastToken"

// Keys to look up localized data for the UI 
#define kTPPDEPanelNameKey                  @"Color Adjustments" 
#define TPPDE_PPD_PANEL_NAME_KEY_LAM     	@"Lamination"
#define TPPDE_PPD_PANEL_NAME_KEY_SHARP     	@"Sharpness"
#define TPPDE_PPD_PANEL_NAME_KEY_MATTE     	@"Matte"
#define TPPDE_PPD_PANEL_NAME_KEY_INFO     	@"Printer Status" 
#define TPPDE_PPD_PANEL_NAME_KEY_COLORMATCH @"Color Matching" 
#define TPPDE_PPD_PANEL_NAME_KEY_FEATURES   @"Features"

// PDE Kind definition
#define TPPDE_PPD_PANEL_KIND_ID_COLOR     	@"com.noritsu.print.pde.coloradjust"
#define TPPDE_PPD_PANEL_KIND_ID_LAM         @"com.noritsu.print.pde.lamination"
#define TPPDE_PPD_PANEL_KIND_ID_SHARP     	@"com.noritsu.print.pde.sharpness"
#define TPPDE_PPD_PANEL_KIND_ID_MATTE     	@"com.noritsu.print.pde.matte"
#define TPPDE_PPD_PANEL_KIND_ID_INFO     	@"com.noritsu.print.pde.info"
#define TPPDE_PPD_PANEL_KIND_ID_CVP         @"com.noritsu.print.pde.cvp"
#define TPPDE_PPD_PANEL_KIND_ID_FEATURES    @"com.dnpphoto.dsclass.pde.features"


#define     PPD_KEY_OPTION_SHARP      @"SharpnessEnabled"
#define     PPD_KEY_OPTION_SHARP_R    @"SharpnessRadius"
#define     PPD_KEY_OPTION_SHARP_I    @"SharpnessIntensity"
#define     PPD_KEY_CHOICE_SHARP_NONE     @"0"
#define     PPD_KEY_CHOICE_SHARP_LOW      @"1"
#define     PPD_KEY_CHOICE_SHARP_MED      @"2"
#define     PPD_KEY_CHOICE_SHARP_HIGH     @"3"

#define     PPD_KEY_OPTION_CUPS11     @"AllowCUPS11"

#define     PPD_KEY_OPTION_COLORMATCH	@"AP_ColorMatchingMode"
#define     PPD_KEY_OPTION_PAPER_INFO_TICKET @"com.apple.print.subTicket.paper_info_ticket"

#define     TPPDE_NETORDER_PAPER_KEY_CACHED @"com.noritsu.netorder.paper.cached"
#define     TPPDE_NETORDER_PAPER_KEY_WIDTH  @"com.noritsu.netorder.paper.width"
#define     TPPDE_NETORDER_PAPER_KEY_NAME   @"com.noritsu.netorder.paper.name"


#define     PPD_KEY_OPTION_NAME       @"PaperName"

#define     PPD_KEY_OPTION_ORIENTATION @"Orientation"

#define     PPD_KEY_CHOICE_NONE           @"None"
#define     PPD_KEY_CHOICE_TOP            @"Top"
#define     PPD_KEY_CHOICE_BOTTOM         @"Bottom"
#define     PPD_KEY_CHOICE_LEFT           @"Left"
#define     PPD_KEY_CHOICE_RIGHT          @"Right"
#define     PPD_KEY_CHOICE_LANDSCAPE      @"Landscape"

#define     PPD_KEY_OPTION_ENABLE_LOGFILE	@"DebugLog"

enum {
    kTPPDEWidgetTag__ZERO	,
    
    // the PDE controls subject to "enable disable must be continuously tagged
    kPDEPPDOptionTagResolution  = 11,
    kPDEPPDChoiceTag300dpi      = 18,
    kPDEPPDChoiceTag600dpi      = 19,
    
    kPDEPPDOptionTagBonus	    = 13,
    
    kPDEPPDOptionTagFinish      = 10,
    kPDEPPDChoiceTagGlossy      = 16,
    kPDEPPDChoiceTagMatte       = 17,
    
    kPDEPPDOptionTagCut         = 12,
    kPDEPPDChoiceTagNormal      = 20,
    kPDEPPDChoiceTagNoWaste     = 14,
    kPDEPPDChoiceTag2Inch       = 15,
    
    kTPPDEControlTagAdjust	    = 512,

    kTPPDESliderTagRed          = 1,
    kTPPDESliderTagGreen	    = 2,
    kTPPDESliderTagBlue         = 3,
    kTPPDESliderTagSaturation   = 4,

    kTPPDESliderTagBrightness   = 5,
    kTPPDESliderTagContrast     = 6,
    kTPPDESliderTagGamma	    = 7,
    kTPPDESliderTagSharpness    = 8,
    
     kTPPDEWidgetTag__LAST	
};

@interface PDEPlugInPrinterDNPDS : NSObject

@end

@interface TPPDEPlugInDNP : NSObject {
}
@end

//@interface TPColorAdjustPDEDNP : ATMPPRBasePDEDNP  {
////	IBOutlet NSView *	PDEView;
//}
//@end
//
//@interface TPSharpnessPDEDNP : ATMPPRBasePDEDNP  {
////	IBOutlet NSView *	sharpView;
//}
//@end
//
//@interface TPColorMatchingPDEDNP : ATMPPRBasePDEDNP  {
//}
//@end
//@interface TPBackprintPDEDNP : ATMPPRBasePDEDNP  {
//    NSCharacterSet *safeSet;
//}
//@end

@interface TPFeaturesPDEDNP : ATMPPRBasePDEDNP  {
//    NSDictionary * paperDict;
//    NSDictionary * _sortedPaper;
//    BOOL        _waitingOnPaper;
//    int         _firstRun;
}
//-(BOOL)hardwareSupportsDuplex;
//-(BOOL)hardwareSupportsExtraFeatures;
@end

//@interface TPUnavailablePDEDNP : ATMPPRBasePDEDNP  {
//}
//@end

