/*
    PDE.m
	Copyright © 2000-2007 TriPrism Inc. All Rights Reserved.

 */

#import "PDE.h"
@interface NSString (TBAtomicPepperExtras)
- (NSString *)stringWithOnlyCharactersInSet:(NSCharacterSet *)set;
@end
@implementation NSString (TBAtomicPepperExtras)
- (NSString *)stringWithOnlyCharactersInSet:(NSCharacterSet *)set
{
    if (NO==[set isKindOfClass:[NSCharacterSet class]])
    {
        return @"";
    }
    NSCharacterSet *invertedSet = [set invertedSet];
    
    NSUInteger i=0, length = [self length];
    NSRange searchRange={0,length};
    NSRange resultRange;
    NSMutableString * str=[NSMutableString stringWithCapacity:length];
    while (resultRange = [self rangeOfCharacterFromSet:invertedSet options:NSLiteralSearch range:searchRange], 0 < resultRange.length)
    {
        i++;
        [str appendString:[self substringToIndex:resultRange.location]];
        resultRange.length = length - resultRange.location;
        searchRange = [self rangeOfCharacterFromSet:set options:NSLiteralSearch range:resultRange];
        if(0 == searchRange.length)
        {
            break;
        }
        searchRange.length = length - searchRange.location;
    }
    if(0 == i)
    {
        return self;
    }
    return [[str copy] autorelease];
}
void printVersionInfo()
{
    
}
@end
@interface ATMPPRBasePDEDNP (privateMethods)
- (CFStringRef)printerDeviceURI;
void initializeUsbtbContext(usbtbTaskContext * jobContext);
void destroyUsbtbJobContext(usbtbTaskContext * jobContext);
void initializeContext(usbtbTaskContext * jobContext);
void destroyJobContext(usbtbTaskContext * jobContext);
- (int) performTaskwithUsbtbWithArgs:(NSArray *) args andContext:(usbtbTaskContext *)jobContext;
-(BOOL)markChoice:(NSString *)choice forPPDOptionKey:(NSString *)ppdOptionKey fromSender:(id)sender;
-(BOOL)enablerState:(id)sender;
- (NSString *)defaultValueForOptionKey:(NSString *)optionKey;
- (NSString *) ppdChoiceForTag:(int)tag;
-(void)speakString:(NSString *)string;
-(void)setGlobalDefaultsObject:(id)object forKey:(id)key;
- (NSArray *)searchView:(NSView *)view forInstancesOfClass:(Class)class;
@end

@implementation PDEPlugInPrinterDNPDS

- (BOOL)initWithBundle:(NSBundle*)theBundle {

    // verify our bundle ...
    BOOL test = ([[theBundle bundleIdentifier] isEqualToString:TPPDE_BUNDLE_ID]);
    if (test)
    {
       // NSLog(@"INIT: loading bundle with id \"%@\"",[theBundle bundleIdentifier]);
    }
    else
    {
        NSLog(@"ERROR: bad bundle id \"%@\" not equal to \"%@\"",[theBundle bundleIdentifier],TPPDE_BUNDLE_ID);
    }
	return test;
	
}

- (NSArray*)PDEPanelsForType:(NSString*)pdeType withHostInfo:(id)host
{
	NSArray *pdes = nil;
	if ([pdeType isEqualToString:(NSString*)kPrinterModuleTypeIDStr])
	{
		// use host to check if the PPD supports the keys, and load the appropriate PDEs
		pdes = [NSArray arrayWithObjects:
                [[[ TPFeaturesPDEDNP alloc] initWithCallback:host] autorelease],
//                [[[ TPBackprintPDENoritsu alloc] initWithCallback:host] autorelease],
//                [[[ TPColorAdjustPDENoritsu alloc] initWithCallback:host] autorelease],
//                [[[ TPSharpnessPDENoritsu alloc] initWithCallback:host] autorelease],
//                [[[ TPUnavailablePDENoritsu alloc] initWithCallback:host] autorelease],
//                [[[ TPColorMatchingPDENoritsu alloc] initWithCallback:host] autorelease],
				nil];
	}

	return pdes;
}
@end

@implementation TPFeaturesPDEDNP

//- (id)newChoiceForSender:(id)sender
//{
//    NSString *string =[NSString stringWithFormat:@"%.2f",[sender floatValue]];
//    string = [sender stringValue];
//
//    return string;
//}
//- (id)newChoiceForSender:(id)sender
//{
//    NSString *choice=nil;
//    if([sender isKindOfClass:[NSMatrix class]])
//    {
//        NSInteger tag = 0;
//        if([sender respondsToSelector:@selector(selectedCell)])
//        {
//            tag = [[sender selectedCell] tag];
//        }
//        else if([sender respondsToSelector:@selector(tag)])
//        {
//            tag = [sender tag];
//        }
//        choice =  [self ppdChoiceForTag:tag];
//    }
//    else if([sender isKindOfClass:[NSTextField class]])
//    {
//        if(NO == [choice = [sender stringValue] isEqualToString:@"-"])
//        {
//            choice = [choice stringByTrimmingCharactersInSet:[[NSCharacterSet characterSetWithCharactersInString:@"0123456789"] invertedSet]];
////            choice = [NSString stringWithFormat:@"%.2f",[choice doubleValue]];
//            choice = [NSString stringWithFormat:@"%d",[choice intValue]];
//        }
//    }
//    else
//    {
//        choice = [sender stringValue];
//    }
//    return choice;
//}
- (NSArray *)supportedPPDOptionKeys;
{
    // list all the custom PPD option key that this PDE will provide
	if (nil == supportedPPDOptionKeys)
	{
		supportedPPDOptionKeys = [[NSArray arrayWithObjects:
                                   PPD_KEY_OPTION_CUT,
                                   PPD_KEY_OPTION_FINISH,
                                   PPD_KEY_OPTION_RESOLUTION,
                                   
                                   PPD_KEY_OPTION_BONUS,    // to waste ribbon or not?
                                   
                                   PPD_KEY_OPTION_ADJUST,
                                   PPD_KEY_OPTION_BRIGHTNESS,
                                   PPD_KEY_OPTION_CONTRAST,
                                   PPD_KEY_OPTION_GAMMA,
                                   PPD_KEY_OPTION_SHARPNESS,
                                   
                                   PPD_KEY_OPTION_SATURATION,
                                   PPD_KEY_OPTION_RED,
                                   PPD_KEY_OPTION_GREEN,
                                   PPD_KEY_OPTION_BLUE,
                                   
                                   PPD_KEY_OPTION_DUPLEX,   // "support" the Duplex key to remove it from apple PDE
                                   nil] retain];
	}
	return supportedPPDOptionKeys;
}
- (NSString*)nibName
{
	return @"DNPPhotoFeatures";
}

// Return the localized name for this PDE. This will be used as its title in the
// menu of printing panes.
- (NSString*)panelName
{
	if (nil == thePDEName){
		thePDEName = [ [ pdeBundle localizedStringForKey:TPPDE_PPD_PANEL_NAME_KEY_FEATURES value:nil table:nil] retain ];
	}
//    NSArray * popups =
//    [self searchView:[NSApp keyWindow].contentView forInstancesOfClass:NSPopUpButton.class ];
//    for (NSPopUpButton * popup in popups)
//    {
//        NSString * selectorName = NSStringFromSelector([popup action]);
//        for (NSMenuItem * item in popup.itemArray)
//        {
//            selectorName = NSStringFromSelector([item action]);
//            NSString * title = item.title;
//            id ro = item.representedObject;
//            BOOL enabled = item.isEnabled;
//            
//        }
//    }

	return thePDEName;
}

// return the kind ID for this PDE
- (NSString*)panelKind
{
	return TPPDE_PPD_PANEL_KIND_ID_FEATURES;
}

- (NSString *) ppdOptionKeyForTag:(int)tag
{
    // this method is the counterpart to [tagForStringValue:]
	NSString *key=nil;
    if(tag & kTPPDEControlValueMask)
    {
        tag ^= kTPPDEControlValueMask;
    }
	switch(tag)
	{
        case kPDEPPDOptionTagResolution:
            key = PPD_KEY_OPTION_RESOLUTION;
            break;
        case kPDEPPDChoiceTag300dpi:
            key = PPD_KEY_CHOICE_300DPI;
            break;
        case kPDEPPDChoiceTag600dpi:
            key = PPD_KEY_CHOICE_600DPI;
            break;

        case kPDEPPDOptionTagBonus:
            key = PPD_KEY_OPTION_BONUS;
            break;
            
        case kPDEPPDOptionTagFinish:
            key = PPD_KEY_OPTION_FINISH;
            break;
        case kPDEPPDChoiceTagGlossy:
            key = PPD_KEY_CHOICE_GLOSSY;
            break;
        case kPDEPPDChoiceTagMatte:
            key = PPD_KEY_CHOICE_MATTE;
            break;
            
        case kPDEPPDOptionTagCut:
            key = PPD_KEY_OPTION_CUT;
            break;
        case kPDEPPDChoiceTagNormal:
            key = PPD_KEY_CHOICE_NORMAL;
            break;
        case kPDEPPDChoiceTagNoWaste:
            key = PPD_KEY_CHOICE_NOWASTE;
            break;
        case kPDEPPDChoiceTag2Inch:
            key = PPD_KEY_CHOICE_2INCH;
            break;
            
        case kTPPDEControlTagAdjust:
            key = PPD_KEY_OPTION_ADJUST;
            break;
            
        case kTPPDESliderTagBrightness:
            key = PPD_KEY_OPTION_BRIGHTNESS;
            break;
        case kTPPDESliderTagContrast:
            key = PPD_KEY_OPTION_CONTRAST;
            break;
        case kTPPDESliderTagGamma:
            key = PPD_KEY_OPTION_GAMMA;
            break;
        case kTPPDESliderTagSharpness:
            key = PPD_KEY_OPTION_SHARPNESS;
            break;

        case kTPPDESliderTagSaturation:
            key = PPD_KEY_OPTION_SATURATION;
            break;
        case kTPPDESliderTagRed:
            key = PPD_KEY_OPTION_RED;
            break;
        case kTPPDESliderTagGreen:
            key = PPD_KEY_OPTION_GREEN;
            break;
        case kTPPDESliderTagBlue:
            key = PPD_KEY_OPTION_BLUE;
            break;
            
        default:
            break;
	}
	return key;
}
- (NSInteger)tagForStringValue:(NSString *)string
{
    // this method is the counterpart to [ppdOptionKeyForTag:]
	NSInteger tag=0;
	if(string)
	{
		if([string isEqualToString:PPD_KEY_CHOICE_300DPI])
		{
			tag = kPDEPPDChoiceTag300dpi;
		}
		else if([string isEqualToString:PPD_KEY_CHOICE_600DPI])
		{
			tag = kPDEPPDChoiceTag600dpi;
		}
		else if([string isEqualToString:PPD_KEY_CHOICE_GLOSSY])
		{
			tag = kPDEPPDChoiceTagGlossy;
		}
		else if([string isEqualToString:PPD_KEY_CHOICE_MATTE])
		{
			tag = kPDEPPDChoiceTagMatte;
		}
		else if([string isEqualToString:PPD_KEY_CHOICE_NORMAL])
		{
			tag = kPDEPPDChoiceTagNormal;
		}
		else if([string isEqualToString:PPD_KEY_CHOICE_NOWASTE])
		{
			tag = kPDEPPDChoiceTagNoWaste;
		}
		else if([string isEqualToString:PPD_KEY_CHOICE_2INCH])
		{
			tag = kPDEPPDChoiceTag2Inch;
		}
	}
	
	return tag;
}
- (NSString *) ppdChoiceForTag:(int)tag
{
    // a choice string for each matrix tag value
    return [self ppdOptionKeyForTag:tag];
//	NSString *key=nil;
//	switch(tag)
//	{
//        case kTPPDESharpnessTagNone:
//            key = PPD_KEY_CHOICE_SHARP_NONE;
//            break;
//        case kTPPDESharpnessTagLow:
//            key = PPD_KEY_CHOICE_SHARP_LOW;
//            break;
//        case kTPPDESharpnessTagMed:
//            key = PPD_KEY_CHOICE_SHARP_MED;
//            break;
//        case kTPPDESharpnessTagHigh:
//            key = PPD_KEY_CHOICE_SHARP_HIGH;
//            break;
//        default:
//            break;
//	}
//	return key;
}
//- (void)controlTextDidChange:(NSNotification *)aNotification
- (void)controlTextDidEndEditing:(NSNotification *)aNotification
{
    [super controlTextDidEndEditing:aNotification];

//    if([[aNotification object] tag] & kTPPDESliderTagIntensity)
//    {
//        [[aNotification object] setStringValue:[NSString stringWithFormat:@"%.2f",[[aNotification object] floatValue]]];
//        [self changePrinterSetting:[aNotification object]];
//    }
}
-(id)view:(NSView *)view controlForTag:(NSInteger)tag
{
    view = view ?: _panelView;
    id control = [view viewWithTag:tag];
    if (nil == control )
    {
        if ([view respondsToSelector:@selector(tabViewItems)])
        {
            for (NSTabViewItem * item in [(NSTabView *)view tabViewItems])
            {
                if((control = [self view:item.view controlForTag:tag]))
                {
                    break;
                }
            }
        }
        else
        {
            for (NSView * subview in view.subviews) {
                if((control = [self view:subview controlForTag:tag]))
                {
                    break;
                }
        }
        }
    }
    return control;
}
-(void)enableCustom
{
    NSString * value = [self ppdValueForAttribute:PPD_KEY_2INCH_SUPPORTED];
    BOOL supported = (value && NSOrderedSame == [@"True" caseInsensitiveCompare:value]);

    //dis(en)able the 2inch cut control
    NSMatrix * control = [self view:nil controlForTag:kPDEPPDOptionTagCut];
    if([control respondsToSelector:@selector(cellWithTag:)])
    {
        [[control cellWithTag:kPDEPPDChoiceTag2Inch] setEnabled:supported];
    }
}

@end
//@implementation TPSharpnessPDENoritsu
//- (NSArray *)supportedPPDOptionKeys;
//{
//	if (nil == supportedPPDOptionKeys)
//	{
//		supportedPPDOptionKeys = [[NSArray arrayWithObjects:PPD_KEY_OPTION_SHARP,PPD_KEY_OPTION_SHARP_I,PPD_KEY_OPTION_SHARP_R,nil] retain];
//	}
//	return supportedPPDOptionKeys;
//}
//- (NSString*)nibName
//{
//    return @"NetOrderSharpness";
//    //	return TPPDE_PPD_PANEL_NAME_KEY_SHARP;
//}
//
//// Return the localized name for this PDE. This will be used as its title in the
//// menu of printing panes.
//- (NSString*)panelName
//{
//	if (nil == thePDEName){
//		thePDEName = [ [ pdeBundle localizedStringForKey:TPPDE_PPD_PANEL_NAME_KEY_SHARP value:nil table:nil] retain ];
//	}
//    
//	return thePDEName;
//}
//- (id)newChoiceForSender:(id)sender
//{
//    NSString *string;// = [sender stringValue];
//    if([sender tag] & kTPPDESliderTagIntensity)
//    {
//        string = [self floatValueForSender:sender format:@"%.2f" allowsNegative:NO];
//        //        if(![sender isKindOfClass:[NSSlider class]])
//        //        {
//        //            string = [string stringByTrimmingCharactersInSet:[[NSCharacterSet characterSetWithCharactersInString:@".0123456789"] invertedSet]];
//        //            string = [NSString stringWithFormat:@"%.2f",[string doubleValue]];
//        //        }
//    }
//    else
//    {
//        string = [NSString stringWithFormat:@"%d",[sender intValue]];
//    }
//    
//    return string;
//}
//// return the kind ID for this PDE
//- (NSString*)panelKind
//{
//	return TPPDE_PPD_PANEL_KIND_ID_SHARP;
//}
//- (NSString *) ppdOptionKeyForTag:(int)tag
//{
//	NSString *key=nil;
//    if(tag & kTPPDEControlValueMask)
//    {
//        tag ^= kTPPDEControlValueMask;
//    }
//	switch(tag)
//	{
//        case kTPPDESliderTagSharpness:
//            key = PPD_KEY_OPTION_SHARP;
//            break;
//        case kTPPDESliderTagRadius:
//            key = PPD_KEY_OPTION_SHARP_R;
//            break;
//        case kTPPDESliderTagIntensity:
//            key = PPD_KEY_OPTION_SHARP_I;
//            break;
//        default:
//            break;
//	}
//	return key;
//}
//- (NSString *) ppdChoiceForTag:(int)tag
//{
//	NSString *key=nil;
//	switch(tag)
//	{
//        case kTPPDESharpnessTagNone:
//            key = PPD_KEY_CHOICE_SHARP_NONE;
//            break;
//        case kTPPDESharpnessTagLow:
//            key = PPD_KEY_CHOICE_SHARP_LOW;
//            break;
//        case kTPPDESharpnessTagMed:
//            key = PPD_KEY_CHOICE_SHARP_MED;
//            break;
//        case kTPPDESharpnessTagHigh:
//            key = PPD_KEY_CHOICE_SHARP_HIGH;
//            break;
//        default:
//            break;
//	}
//	return key;
//}
////- (void)controlTextDidChange:(NSNotification *)aNotification
//- (void)controlTextDidEndEditing:(NSNotification *)aNotification
//{
//    [super controlTextDidEndEditing:aNotification];
//    
//    if([[aNotification object] tag] & kTPPDESliderTagIntensity)
//    {
//        [[aNotification object] setStringValue:[NSString stringWithFormat:@"%.2f",[[aNotification object] floatValue]]];
//        [self changePrinterSetting:[aNotification object]];
//    }
//}
//- (NSInteger)tagForStringValue:(NSString *)string
//{
//	NSInteger tag=0;
//	if(string)
//	{
//		if([string isEqualToString:PPD_KEY_CHOICE_SHARP_NONE])
//		{
//			tag = kTPPDESharpnessTagNone;
//		}
//		else if([string isEqualToString:PPD_KEY_CHOICE_SHARP_LOW])
//		{
//			tag = kTPPDESharpnessTagLow;
//		}
//		else if([string isEqualToString:PPD_KEY_CHOICE_SHARP_MED])
//		{
//			tag = kTPPDESharpnessTagMed;
//		}
//		else if([string isEqualToString:PPD_KEY_CHOICE_SHARP_HIGH])
//		{
//			tag = kTPPDESharpnessTagHigh;
//		}
//	}
//	
//	return tag;
//}
////- (id)newChoiceForSender:(id)sender
////{
////    NSString *choice=nil;
////    if([sender isKindOfClass:[NSMatrix class]])
////    {
////        NSInteger tag = 0;
////        if([sender respondsToSelector:@selector(selectedCell)])
////        {
////            tag = [[sender selectedCell] tag];
////        }
////        else if([sender respondsToSelector:@selector(tag)])
////        {
////            tag = [sender tag];
////        }
////        choice =  [self ppdChoiceForTag:tag];
////    }
////    else if([sender isKindOfClass:[NSTextField class]])
////    {
////        if(NO == [choice = [sender stringValue] isEqualToString:@"-"])
////        {
////            choice = [choice stringByTrimmingCharactersInSet:[[NSCharacterSet characterSetWithCharactersInString:@".0123456789"] invertedSet]];
////            choice = [NSString stringWithFormat:@"%.2f",[choice doubleValue]];
////        }
////    }
////    else
////    {
////        choice = [sender stringValue];
////    }
////    return choice;
////}
//@end

//
//#pragma mark -
//@implementation TPUnavailablePDENoritsu
//- (NSArray *)supportedPPDOptionKeys;
//{
//	if (nil == supportedPPDOptionKeys)
//	{
//		supportedPPDOptionKeys = [[NSArray arrayWithObjects:@"AP_CoverPage",nil] retain];
//	}
//	return supportedPPDOptionKeys;
//}
//- (NSString*)nibName
//{
//	return @"NetOrderUnavailable";
//}
//
//// Return the localized name for this PDE. This will be used as its title in the
//// menu of printing panes.
//- (NSString*)panelName
//{
//	if (nil == thePDEName){
//		thePDEName = [ [ pdeBundle localizedStringForKey:@"Cover Page" value:nil table:nil] retain ];
//	}
//	
//	return thePDEName;
//}
//
//// return the kind ID for this PDE
//- (NSString*)panelKind
//{
//	return (NSString*)kPMCoverPagePDEKindID;
//}
//- (BOOL)restoreValuesAndReturnError:(NSError **)error
//{
////    CFDictionaryRef settingsDictionary=NULL;
////    PMPrintSettingsCopyAsDictionary((PMPrintSettings)[pdePluginCallbackObject printSettings], &settingsDictionary);
////    NSLog(@"Print settings:%@",settingsDictionary);
////    CFRelease(settingsDictionary);
//    [self saveValuesAndReturnError:nil];
//	return YES;
//}
//- (BOOL)saveValuesAndReturnError:(NSError **)error
//{	
//	PMPrintSettings settings = (PMPrintSettings)[pdePluginCallbackObject printSettings];
//    OSStatus err;
//    NSString * optionKey = @"job-sheets";
//    NSString *choice = nil;
//    NSString *noneChoice = PPD_KEY_CHOICE_NONE;
//	if(settings && useConstraintHandling)
//	{
//        err = PMPrintSettingsGetValue(settings, (CFStringRef)optionKey, (CFTypeRef *)&choice);
//        if(!err && ![choice isEqualToString:noneChoice])
//        {
//            NSLog(@"Print settings:%@ = %@",optionKey,choice);
//            err = PMPrintSettingsSetValue(settings, (CFStringRef)optionKey, (CFTypeRef)noneChoice, kPMUnlocked);
//            err = PMPrintSettingsGetValue(settings, (CFStringRef)optionKey, (CFTypeRef *)&choice);
//            NSLog(@"After change ... %@ = %@",optionKey,choice);
//        }
//    }
//	return YES;
//}
//-(id)initWithCallback:(id)callback
//{
//    if(self = [super initWithCallback:callback])
//    {
//        [self saveValuesAndReturnError:nil];
//    }
//    return self;
//}
//@end
//#pragma mark -
//@implementation TPColorMatchingPDENoritsu
//- (NSArray *)supportedPPDOptionKeys;
//{
//	if (nil == supportedPPDOptionKeys)
//	{
//		supportedPPDOptionKeys = [[NSArray arrayWithObjects:@"AP_ColorMatchingMode",nil] retain];
//	}
//	return supportedPPDOptionKeys;
//}
//- (NSString*)nibName
//{
//	return @"NetOrderColorMatching";
//}
//
//// Return the localized name for this PDE. This will be used as its title in the
//// menu of printing panes.
//- (NSString*)panelName
//{
//	if (nil == thePDEName){
//		thePDEName = [ [ pdeBundle localizedStringForKey:TPPDE_PPD_PANEL_NAME_KEY_COLORMATCH value:nil table:nil] retain ];
//	}
//	
//	return thePDEName;
//}
//
//// return the kind ID for this PDE
//- (NSString*)panelKind
//{
//	return (NSString*)TPPDE_PPD_PANEL_KIND_ID_INFO;
////	return (NSString*)kPMColorMatchingPDEKindID;//AP_ApplicationColorMatching//AP_ColorMatchingMode
//}
//- (NSString *) ppdOptionKeyForTag:(int)tag
//{
//    NSString *key=nil;
//	switch(tag)
//	{
//		case 1:
//			key = PPD_KEY_OPTION_COLORMATCH;
//			break;
//		default:
//			break;
//	}
//	return key;
//}
//@end
//
//#pragma mark -
//@implementation TPBackprintPDENoritsu
//- (NSArray *)supportedPPDOptionKeys;
//{
//	if (nil == supportedPPDOptionKeys)
//	{
//		supportedPPDOptionKeys = [[NSArray arrayWithObjects:
//            PPD_KEY_OPTION_CVP1,
//            PPD_KEY_OPTION_CVP2,
//            PPD_KEY_OPTION_ENABLE_CVP1,
//            PPD_KEY_OPTION_ENABLE_CVP2,
//            PPD_KEY_OPTION_ENABLE_LOGFILE,
//        nil] retain];
//	}
//	return supportedPPDOptionKeys;
//}
//- (NSString*)nibName
//{
//	return @"NetOrderCVP";
//}
//
//// Return the localized name for this PDE. This will be used as its title in the
//// menu of printing panes.
//- (NSString*)panelName
//{
//	if (nil == thePDEName){
//		thePDEName = [ [ pdeBundle localizedStringForKey:TPPDE_PPD_PANEL_NAME_KEY_CVP value:nil table:nil] retain ];
//	}
//	
//	return thePDEName;
//}
//
//// return the kind ID for this PDE
//- (NSString*)panelKind
//{
//	return (NSString*)TPPDE_PPD_PANEL_KIND_ID_CVP;
//}
//- (NSString *) ppdOptionKeyForTag:(int)tag
//{
//    NSString *key=nil;
//	switch(tag)
//	{
//		case 1:
//			key = PPD_KEY_OPTION_CVP1;
//			break;
//		case 2:
//			key = PPD_KEY_OPTION_CVP2;
//			break;
//		case kTPPDE_EnableToggleTag | 0:
//			key = PPD_KEY_OPTION_ENABLE_CVP1;
//			break;
//		case kTPPDE_EnableToggleTag | 1:
//			key = PPD_KEY_OPTION_ENABLE_CVP2;
//			break;
//		case kTPPDE_EnableToggleTag | 2:
//			key = PPD_KEY_OPTION_ENABLE_LOGFILE;
//			break;
//		default:
//			break;
//	}
//	return key;
//}
//- (void)willShow
//{
//    [self speakString:@"Enter up to two lines of text to appear on the back side of the picture."];
////    NSLog ( @"will show backprint");
//}
//-(NSString *)stringWithSafeCharacters:(NSString *)string
//{
//    NSMutableString *mString = [string mutableCopy];
//    [mString replaceOccurrencesOfString:@"," withString:@"≤" options:0 range:NSMakeRange(0, [mString length])];
//    [mString replaceOccurrencesOfString:@"'" withString:@"æ" options:0 range:NSMakeRange(0, [mString length])];
//    string = [mString copy];
//    [mString release];
//    return [string autorelease];
//}
//-(NSString *)stringWithUnsafeCharacters:(NSString *)string
//{
//    NSMutableString *mString = [string mutableCopy];
//    [mString replaceOccurrencesOfString:@"≤" withString:@"," options:0 range:NSMakeRange(0, [mString length])];
//    [mString replaceOccurrencesOfString:@"æ" withString:@"'" options:0 range:NSMakeRange(0, [mString length])];
//    string = [mString copy];
//    [mString release];
//    return [string autorelease];
//}
//- (NSString *)limitCVPValue:(NSString *)choice
//{
//    while (1)
//    {
//        if(kNoritsuMaxLengthCVP < [choice length] && !((kNoritsuMaxLengthCVP +1)==[choice length] && [[choice substringFromIndex:kNoritsuMaxLengthCVP] isEqualToString:@" "]))
//        {
//            choice = [choice substringToIndex:kNoritsuMaxLengthCVP];
//        }
//        else if (0 < [choice length] && NSOrderedSame == [choice compare:@"\\"  options:NSLiteralSearch range:NSMakeRange([choice length] -1, 1)])
//        {
//            choice = [choice stringByAppendingFormat:@" "];
//        }
//        else
//        {
//            break;
//        }
//    }
//    return choice;
//}
//- (void)controlTextDidEndEditing:(NSNotification *)aNotification
//{
////    NSLog(@"%@",[[aNotification object] stringValue]);
//    NSString * ppdOptionKey = [self ppdOptionKeyForTag:[[aNotification object] tag]];
//    NSString *unsafe = [[aNotification object] stringValue];
//    NSString *choice = [self limitCVPValue:unsafe];
//    if(NO == [choice isEqualToString:unsafe])
//    {
//        [[aNotification object] setStringValue:choice];
//    }
//    [self setChoice:[self stringWithSafeCharacters:choice] forKey:ppdOptionKey];
//    [self changePrinterSetting:[aNotification object]];
//}
//- (void)controlTextDidChange:(NSNotification *)aNotification
//{
////    NSTextField *tf=[aNotification object];
////    NSLog(@"%@",[tf stringValue]);
//    
//    NSString * ppdOptionKey = [self ppdOptionKeyForTag:[[aNotification object] tag]];
//    NSString *choice = [[aNotification object] stringValue];
//    NSString *safeString = [choice stringWithOnlyCharactersInSet:safeSet];
//    
//    BOOL didModify=NO;
//    if(NO == [safeString isEqualToString:choice])
//    {
//    
//        choice = safeString;
//        didModify = YES;
//    }
//    if (kNoritsuMaxLengthCVP < [choice length])
//    {
//        choice = [choice substringToIndex:kNoritsuMaxLengthCVP];
//        didModify=YES;
//    }
//    [self setChoice:choice forKey:ppdOptionKey];
//    if(didModify)
//    {
//        [[aNotification object] setStringValue:choice];
//        NSBeep();
//    }
////    [self changePrinterSetting:[aNotification object]];
//}
//- (id)newChoiceForSender:(id)sender
//{
//    NSString * choice = [self stringWithSafeCharacters:[sender stringValue]];
//    return choice;
//}
//- (void)updateControl:(id)control withValue:(id)value
//{
//    if([control isKindOfClass:[NSTextField class]])
//    {
//        [control setStringValue:[self stringWithUnsafeCharacters:value]];
//    }
//    else
//    {
//        [super updateControl:control withValue:value];
//    }
//}
//- (BOOL)saveValuesAndReturnError:(NSError **)error
//{
//    PMPrintSettings settings = (PMPrintSettings)[pdePluginCallbackObject printSettings];
//    OSStatus err;
//	if(settings && useConstraintHandling)
//	{
//		NSString *value=nil;
//		NSEnumerator *optionsEnum = [[self supportedPPDOptionKeys] objectEnumerator];
//		NSString * optionKey;
//		while (optionKey=[optionsEnum nextObject])
//		{
//            value = [choiceDict objectForKey:optionKey];
//            if (2 < [optionKey length] && NSOrderedSame == [optionKey compare:@"CVP" options:NSLiteralSearch range:NSMakeRange(0, 3)])
//            {
//                value = [self stringWithSafeCharacters:value];
//            }
//            err = PMPrintSettingsSetValue(settings, (CFStringRef)optionKey, (CFTypeRef)value, kPMUnlocked);
//            // do appropriate thing when there is an error. Here we write it
//            if(err)
//            {
//                NSLog(@"PDE got an error %d setting the value for %@ !", err, optionKey);
//            }
//        }
//    }
//
//	return YES;
//}
//
//// read the new settings values and update our internal PDE's settings accordingly
//- (BOOL)restoreValuesAndReturnError:(NSError **)error
//{	
//	PMPrintSettings settings = (PMPrintSettings)[pdePluginCallbackObject printSettings];
//    OSStatus err;
//	if(settings && useConstraintHandling)
//	{
//		// In this case, settings corresponding to PPD options are maintained by the implementation and do not come from 
//		// the print settings but instead from the cups ppd calls. The currently marked choice is the setting for the
//		// PPD option(s).
//		NSString *choice=nil;
//		NSEnumerator *optionsEnum = [[self supportedPPDOptionKeys] objectEnumerator];
//		NSString * optionKey;
//		while (optionKey=[optionsEnum nextObject])
//		{
//            err = PMPrintSettingsGetValue(settings, (CFStringRef)optionKey, (CFTypeRef *)&choice);
//            if(err)
//            {
//                // No setting for key in ticket so Use a default value.
//                choice = [self defaultValueForOptionKey:optionKey];
//                err = noErr;
//            }
////            if (2 < [optionKey length] && NSOrderedSame == [optionKey compare:@"CVP" options:NSLiteralSearch range:NSMakeRange(0, 3)])
////            {
////                choice = [self stringWithUnsafeCharacters:[self limitCVPValue:choice]];
////            }
//            [self setChoice:choice forKey:optionKey];
//		}
//	}
//	else
//	{
//		[ self getPPDSettingsFromPrintSettingsOnTiger ];
//		if([choiceDict count] != [[self supportedPPDOptionKeys] count])
//			[self setDefaults];
//	}
//
//	// Now have UI reflect the current settings.
//	[self updateUI];
//		
//	return YES;
//}
//- (void)setControlsEnabledByToggle:(id)sender
//{
//    BOOL isEnabled = [self enablerState:sender];
//    int tag=([sender tag] & 0x0F) + 1;
//    NSControl *control=[[sender superview] viewWithTag:tag];
//    if(control)
//    {
//        [control setEnabled:isEnabled];
//    }
//    control=[[sender superview] viewWithTag:kTPPDEPopupButtonTag];
//    if(control)
//    {
//        if(isEnabled && NO==[control isEnabled])
//        {
//            [control setEnabled:YES];
//            [[[sender superview] viewWithTag:kTPPDEPopupButtonTag + 1] setEnabled:YES];
//        }
//        else if (![[[sender superview] viewWithTag:kTPPDE_EnableToggleTag] state] && ![[[sender superview] viewWithTag:kTPPDE_EnableToggleTag+1] state])
//        {
//            [control setEnabled:NO];
//            [[[sender superview] viewWithTag:kTPPDEPopupButtonTag + 1] setEnabled:NO];
//        }
//    }
//}
////- (NSString *)defaultValueForOptionKey:(NSString *)optionKey
////{
////    NSString *choice=nil;
////
////    if(5 < [optionKey length])
////    {
////        choice = [super defaultValueForOptionKey:optionKey];
////    }
////    else if (ppd)
////    {
////        ppd_attr_t *attr = ppdFindAttr(ppd, [[NSString stringWithFormat:@"%@Default",optionKey] UTF8String], NULL);
////        if(attr && attr->value)
////        {
////            choice = [NSString stringWithUTF8String:attr->value];
////        }
////    }
////    return choice;
////}
//- (IBAction)sendUICommand:(id)sender
//{
//    NSTextView * text=nil;
//    NSString *token;
//    if( [(text=(NSTextView *)[[sender window] firstResponder]) isKindOfClass:[NSTextView class]] && [[text delegate] respondsToSelector:@selector(delegate)] && [[[text delegate] delegate] isEqual:self] )
//    {
//        NSPopUpButton *button=[[sender superview] viewWithTag:kTPPDEPopupButtonTag];
//        if([button isKindOfClass:[NSPopUpButton class]])
//        {
//            token = [[button selectedItem] representedObject];
//            if([token isKindOfClass:[NSString class]])
//            {
//                [text insertText:token];
//                [self setGlobalDefaultsObject:token forKey:TPPDE_USER_DEFAULTS_ID_LAST_TOKEN];
////                [[NSUserDefaults standardUserDefaults] setObject:token forKey:TPPDE_USER_DEFAULTS_ID_LAST_TOKEN];
//            }
//        }
//    }
//}
//-(void)populateMenuObjectsInView:(id)view
//{
//    NSInteger i=0;
//    NSPopUpButton * popup=[view viewWithTag:kTPPDEPopupButtonTag];
//    NSString *title;
//    NSString *token;
//    NSArray * items = [NSArray arrayWithObjects:
//                                                @"[YYYY]",
//                                                @"[YY]",
//                                                @"[DD]",
//                                                @"[D]",
//                                                @"[MM]",
//                                                @"[M]",
//                                                @"[C]",
//                                                @"[F]",
//                                                @"[P]",
//                                                @"[U]",
//                                                nil];
//    NSEnumerator *itemEnum=[items objectEnumerator];
//    if(itemEnum && [popup isKindOfClass:[NSPopUpButton class]])
//    {
//        [popup removeAllItems];
//        while(token=[itemEnum nextObject])
//        {
//            title = [pdeBundle localizedStringForKey:token value:nil table:nil];
//            [popup addItemWithTitle:title];
//            [[popup itemAtIndex:i++] setRepresentedObject:token];
//        }
//        token = [[NSUserDefaults standardUserDefaults] stringForKey:TPPDE_USER_DEFAULTS_ID_LAST_TOKEN];
//        if(title = [pdeBundle localizedStringForKey:token value:nil table:nil])
//        {
//            [popup selectItemWithTitle:title];
//        }
//        else
//        {
//            [popup selectItemAtIndex:0];
//        }
//        [popup synchronizeTitleAndSelectedItem];
//    }    
//}
//-(void)setToolTip:(id)value fromSender:(id)sender
//{
//	[sender setToolTip:@""];
//}
//-(id)initWithCallback:(id)callback
//{
//    if(self = [super initWithCallback:callback])
//    {
//        NSMutableCharacterSet *mSet = [NSMutableCharacterSet characterSetWithRange:NSMakeRange(' ', '~' - ' ')];
//        [mSet addCharactersInString:@"©"];
//        safeSet = [mSet copy];
//        [self restoreValuesAndReturnError:nil];
//        [self saveValuesAndReturnError:nil];
//    }
//    return self;
//}
//- (void) dealloc
//{
//    [safeSet release];
//    [super dealloc];
//}
//
//@end
//
//
//#pragma mark -
//@implementation TPFeaturesPDENoritsu
//-(NSString *)logfile
//{
//    return [[[@ NORITSU_PDE_LOG_FOLDER stringByAppendingPathComponent:@ NORITSU_PDE_LOGFILE] stringByAppendingString:NSUserName()]stringByAppendingPathExtension:@"log"];
//}
//- (BOOL)setDuplexEnabled:(BOOL)enabled
//{
//    PMPrintSettings settings = (PMPrintSettings)[pdePluginCallbackObject printSettings];
//    OSStatus err = 1;
//	if(settings)
//	{
//		NSString * optionKey = @"com.apple.print.PrintSettings.PMDuplexing";
//        NSNumber * value = [NSNumber numberWithBool:enabled];
//        err = PMPrintSettingsSetValue(settings, (CFStringRef)optionKey, (CFTypeRef)value, kPMUnlocked);
//    }
//    return (! err);
//}
//- (NSArray *)supportedPPDOptionKeys;
//{
//	if (nil == supportedPPDOptionKeys)
//	{
//		supportedPPDOptionKeys = [[NSArray arrayWithObjects:
//            PPD_KEY_OPTION_FEED,
////            PPD_KEY_OPTION_FEED_FAKE,
//            PPD_KEY_OPTION_NAME,
//            PPD_KEY_OPTION_WIDTH,
//            PPD_KEY_OPTION_SURFACE,
//            PPD_KEY_OPTION_RESOLUTION,
//            PPD_KEY_OPTION_TONE,
//            PPD_KEY_OPTION_OVERSPILL,
//            PPD_KEY_OPTION_BINDMARGIN,
//            PPD_KEY_OPTION_BINDWIDTH,
////            @"cupsBorderlessScalingFactor",
//            PPD_KEY_OPTION_RESIZE,
//            PPD_KEY_OPTION_TWO_SIDED,
//            @"Duplex",
//            PPD_KEY_OPTION_LAST_REZ,
////            @"PageSize",
////            @"PageRegion",
////            @"PaperDimension",
////            @"ImageableArea",
//            nil] retain];
//	}
//	return supportedPPDOptionKeys;
//}
//-(NSInteger)indexOfMenuItem:(id)control forValue:(NSString *)value
//{
//    NSInteger index = 0;
//    switch ([control respondsToSelector:@selector(tag)] ? [control tag] : 0)
//    {
//    case kTPPDEPopupTagPaperWidth:
//    case kTPPDEPopupTagPaperName:
////        if(value && [control respondsToSelector:@selector(indexOfItemWithTitle:)])
////        {
////            index = [control indexOfItemWithTitle: value];
////        }
////        break;
//    default:
//        if(value && [control respondsToSelector:@selector(indexOfItemWithRepresentedObject:)])
//        {
//            index = [control indexOfItemWithRepresentedObject:value];
//        }
//        break;
//    }
//    if(0 > index && [control respondsToSelector:@selector(numberOfItems)] && 0 < [control numberOfItems])
//    {
//        index = 0;
//    }
//    return index;
//}
//-(NSDictionary *)unsortedPaper
//{
//    return paperDict;
//}
//-(void)setUnsortedPaper:(id)paper
//{
//    paper = [paper retain];
//    [paperDict release];
//    paperDict = paper;
//}
//-(NSArray *)resolutionsForPaper:(NSString *)key
//{
//    NSDictionary * thisPaper = [[self unsortedPaper] objectForKey:key];
//    NSDictionary * aPaper;
//    NSNumber * resolution = [thisPaper objectForKey:@"paperResolution"];
//    NSArray * resolutions = [NSArray arrayWithObject:[resolution stringValue]];
//    NSNumber * source = [thisPaper objectForKey:@"paperSource"]; //source is 1 for sheet-fed, zero for roll
//    NSNumber * width = nil;
//    NSString *name = nil;
//    NSEnumerator * e = [[self unsortedPaper] objectEnumerator];
//    if(source && ( name = [thisPaper objectForKey:@"paperName"] ))
//    {
//        while (aPaper = [e nextObject])
//        {
//            if( aPaper == thisPaper )
//            {
//                continue;
//            }
//            if( [name isEqualToString:[aPaper objectForKey:@"paperName"]] )
//            {
//                resolutions = [resolutions arrayByAddingObject:[[aPaper objectForKey:@"paperResolution"] stringValue]];
//            }
//        }
//    }
//    else
//    {
//        width = [aPaper objectForKey:@"paperWidth"];
//        while (aPaper = [e nextObject])
//        {
//            if( aPaper == thisPaper )
//            {
//                continue;
//            }
//            if( [width isEqualToNumber:[aPaper objectForKey:@"paperWidth"]] )
//            {
//                resolutions = [resolutions arrayByAddingObject:[[aPaper objectForKey:@"paperResolution"] stringValue]];
//            }
//        }
//    }
//    return resolutions;
//}
////-(BOOL)validateMenuItem:(NSMenuItem *)item
////{
////    BOOL enabled = NO;
////    NSPopUpButton * popup;
////    switch ([item tag])
////    {
////        case kTPPDEPopupTagPaperResolution:
////            if( [popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperName] isEnabled] )
////            {
////                if( [[[_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_NAME] objectForKey:[popup titleOfSelectedItem]] containsObject:[item title]] )
////                {
////                    enabled = YES;
////                }
////            }
////            else if( [popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperWidth] isEnabled] )
////            {
////                NSString *surface = [choiceDict objectForKey:PPD_KEY_OPTION_SURFACE];
////                NSString *width = [popup titleOfSelectedItem];
////                NSString * dpi = [item title];
////                //[[[[self panelView] viewWithTag:kTPPDEMatrixTagSurface] selectedCell] stringValue]
////                if( [[[[_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_WIDTH] objectForKey:width] objectForKey:surface] containsObject:dpi] )
////                {
////                    enabled = YES;
////                }
////            }
////            break;
////        default:
////            break;
////    }
////
////    return enabled;
////}
//-(NSArray *)sortedPaperNames
//{
//    return [[[_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_NAME] allKeys] sortedArrayUsingSelector:@selector(numericalCaseInsensitiveCompare:)];
//}
//-(NSArray *)sortedPaperWidths
//{
//    return [[[_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_WIDTH] allKeys] sortedArrayUsingSelector:@selector(numericalCaseInsensitiveCompare:)];
//}
//-(NSString *)humanReadablePaperWidthForActual:(NSString *)title
//{
//    NSString * humanReadable = nil;
//    if([title length])
//    {
//        NSString * extra = [title substringFromIndex:[title length] -1];
//        if([extra isEqualToString:@"0"])
//        {
//            extra = @"";
//        }
//        else
//        {
//            extra = [NSString stringWithFormat:@".%@", extra];
//        }
//        humanReadable = [NSString stringWithFormat:@"%@%@ mm", [title substringToIndex:[title length] -1], extra];
//    }
//    return humanReadable;
//}
//-(void)updatePaperUI
//{
//    db( "entering %s", __func__ );
//    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
//    //[self speakString:@"updating Paper UI"];
//    NSArray * array;
//    NSEnumerator * e;
//    NSMenuItem * item;
//    NSPopUpButton * p;
//    NSView * view = _panelView;
//    
//    db( "about to get sortedPaperNames in %s", __func__ );
//    array = [self sortedPaperNames];
//    BOOL supportsSheet = (BOOL)[array count];
////    p = [view viewWithTag: kTPPDEPopupTagPaperFeed];
////    item = [p itemAtIndex:[p indexOfItemWithRepresentedObject:PPD_KEY_CHOICE_SHEET]];
////    [item setEnabled:supportsSheet];
//    p = [view viewWithTag: kTPPDEPopupTagPaperName];
//    [p removeAllItems];
//    if( supportsSheet )
//    {
//        [p addItemsWithTitles:array];
//        e = [[p itemArray] objectEnumerator];
//        while ( item = [e nextObject] )
//        {
//            [item setTag:kTPPDEPopupTagPaperName];
//            [item setRepresentedObject:[item title]];
//        }
//    }
////    else
////    {
////        // select Roll
////        [self markChoice:PPD_KEY_CHOICE_ROLL forPPDOptionKey:PPD_KEY_OPTION_FEED fromSender:[view viewWithTag: kTPPDEPopupTagPaperFeed] ];
////    }
//
//    [p = [view viewWithTag: kTPPDEPopupTagPaperWidth] removeAllItems];
//    if( (array = [self sortedPaperWidths]) && [array count] )
//    {
//        [p addItemsWithTitles:array];
//        e = [[p itemArray] objectEnumerator];
//        while ( item = [e nextObject] )
//        {
//            [item setTag:kTPPDEPopupTagPaperName];
//            [item setRepresentedObject:[item title]];
//            [item setTitle:[self humanReadablePaperWidthForActual:[item title]]];
//            
//        }
//    }
//    [pool drain];
//    db( "exiting %s", __func__ );
//}
//-(BOOL)isLandscapeOrientation
//{
//    BOOL isLandscape = NO;
////    [[choiceDict objectForKey:PPD_KEY_OPTION_ORIENTATION] isEqualToString:PPD_KEY_CHOICE_LANDSCAPE] )
//    PMPageFormat format = [pdePluginCallbackObject pageFormat];
//    PMOrientation orientation;
//    if ( noErr == PMGetOrientation(format, &orientation) )
//    {
//        isLandscape = ( kPMLandscape ==  orientation || kPMReverseLandscape ==  orientation );
//    }
//    return isLandscape;
//}
//-(NSString *)bindingMarginForMargin:(NSString *)choice reverse:(BOOL)reverse
//{
//    if( NO == [choice isEqualToString:PPD_KEY_CHOICE_NONE] && [self isLandscapeOrientation] )
//    {
//        NSString * oldChoice = choice;
//        //flop the binding margin sides to keep in sync with visual orientation:
//        // Bottom -> Left
//        // Top -> Right
//        // Left -> Top
//        // Right -> Bottom
//        if( [choice isEqualToString:PPD_KEY_CHOICE_BOTTOM] )
//        {
//            if(reverse)
//            {
//                choice = PPD_KEY_CHOICE_LEFT;
//            }
//            else
//            {
//                choice = PPD_KEY_CHOICE_RIGHT;
//            }
//        }
//        else if( [choice isEqualToString:PPD_KEY_CHOICE_TOP] )
//        {
//            if(reverse)
//            {
//                choice = PPD_KEY_CHOICE_RIGHT;
//            }
//            else
//            {
//                choice = PPD_KEY_CHOICE_LEFT;
//            }
//        }
//        else if( [choice isEqualToString:PPD_KEY_CHOICE_LEFT] )
//        {
//            if(reverse)
//            {
//                choice = PPD_KEY_CHOICE_TOP;
//            }
//            else
//            {
//                choice = PPD_KEY_CHOICE_BOTTOM;
//            }
//        }
//        else if( [choice isEqualToString:PPD_KEY_CHOICE_RIGHT] )
//        {
//            if(reverse)
//            {
//                choice = PPD_KEY_CHOICE_BOTTOM;
//            }
//            else
//            {
//                choice = PPD_KEY_CHOICE_TOP;
//            }
//        }
//        if(! reverse)
//        {
//            db( "flopping \"Binding Margin\" from \"%@\" to \"%@\" for \"Landscape\" orientation", oldChoice, choice );
//        }
//    }
//    return choice;
//}
//-(BOOL)paperIsTallerThanWide
//{
////    NSPrintInfo * info = [NSPrintInfo sharedPrintInfo];
//    //info = [[NSPrintOperation currentOperation] printInfo];
//    NSSize size;// = [info paperSize];
////    size.height = size.width;
////    [info setPaperSize:size];
//    PMPageFormat format = [pdePluginCallbackObject pageFormat];
//    PMOrientation orientation;
//    PMGetOrientation(format, &orientation);
//    PMRect r;
//    PMGetUnadjustedPaperRect(format, & r);
//    size.height = r.bottom - r.top;
//    size.width = r.right - r.left;
//    //db( "unadjusted paper rect: left = %.f, bottom = %.f, top = %.f, right = %.f", r.left, r.bottom, r.top, r.right );
//    PMGetAdjustedPaperRect(format, & r);
//    //db( "adjusted paper rect: left = %.f, bottom = %.f, top = %.f, right = %.f", r.left, r.bottom, r.top, r.right );
////    PMPrintSession session = [pdePluginCallbackObject printSession];
//    BOOL s = ( size.width < size.height );
//    if( kPMLandscape ==  orientation || kPMReverseLandscape ==  orientation  )
//    {
//        s = !s;
//    }
////    if( NSLandscapeOrientation == [info orientation] )
////    {
////        s = !s;
////    }
//    //db( "paperIsTallerThanWide ? %s (W = %.f H = %.f Orientation = %s (%d))", s ? "YES":"NO", size.width, size.height, ( NSLandscapeOrientation == [info orientation] ) ? "Landscape":"Portrait" , orientation);
//    return s;
//}
//-(void)didSelectTwoSided:(NSNotification *)note
//{
//    NSPopUpButton * popup = [[self panelView] viewWithTag:kTPPDEPopupTagBindingMargin];
////    NSString * popupSelectionVisible = [[popup selectedItem] representedObject];
////    NSString * popupSelection = [self bindingMarginForMargin:popupSelectionVisible reverse:NO];
//    NSString * printSystemSelection = [self printSystemValueForKey:PPD_KEY_OPTION_TWO_SIDED];
//
////    if([printSystemSelection isEqualToString:popupSelection])
////    {
////        // Do nothing when nothing has changed
////        return;
////    }
//
//    // update the available binding options based on the shape of the paper
//    NSEnumerator * e = [[popup itemArray] objectEnumerator];
//    NSMenuItem * item;
//    BOOL longEdge = [printSystemSelection isEqualToString:PPD_KEY_CHOICE_EDGE_LONG];
//    BOOL normal = [self paperIsTallerThanWide] ? longEdge : ! longEdge;
//    // long-edge binding taller than wide or ... enables left and right, disabled Top and Bottom
//    while(item = [e nextObject])
//    {
//        if( [[item representedObject] isEqualToString:PPD_KEY_CHOICE_NONE] )
//        {
//            [item setEnabled: YES];
//        }
//        else if( [[item representedObject] isEqualToString:@"Left"] || [[item representedObject] isEqualToString:@"Right"] )
//        {
//            [item setEnabled: normal];
//        }
//        else
//        {
//            [item setEnabled: !normal];
//        }
//    }
//    // modify the selection if existing is now disabled
//    NSInteger index = [popup indexOfItemWithRepresentedObject:[self bindingMarginForMargin:[self printSystemValueForKey:PPD_KEY_OPTION_BINDMARGIN] reverse:YES]];
//    if( [popup indexOfSelectedItem] != index )
//    {
//        // change the control setting to represent the actual value
//        [popup selectItemAtIndex:index];
//    }
//    if( NO == [[popup selectedItem] isEnabled] && [[popup itemArray] count] )
//    {
//        item = nil;
//        if( [popup isEnabled] )
//        {
//            // locate the first enabled item that is not "None" (at index 0)
//            index = 1;
//            while( [[popup itemArray] count] > index && ( item = [popup itemAtIndex:index++] ) && NO == [item isEnabled] );
//        }
//        if( item )
//        {
//            [popup selectItem:item];
//        }
//        else
//        {
//            [popup selectItemAtIndex:0];
//        }
//        [popup synchronizeTitleAndSelectedItem];
//    }
//    [self changePrinterSetting:popup];
//}
//-(NSDictionary *)match
//{
//    NSDictionary *matchedPaper = nil;
//    NSString * paperKey;
//    NSPopUpButton * pbRez = [[self panelView] viewWithTag:kTPPDEPopupTagPaperResolution];
//    NSString * rez = [[pbRez selectedItem] representedObject];
//    rez = [[pbRez selectedItem] title];
//    NSUInteger r = [rez intValue];
//    if([[choiceDict objectForKey:PPD_KEY_OPTION_FEED] isEqualToString:PPD_KEY_CHOICE_SHEET])
//    {
//        paperKey = [NSString stringWithFormat:@"%@-r%u",[choiceDict objectForKey:PPD_KEY_OPTION_NAME], r];
//    }
//    else
//    {
//        paperKey = [NSString stringWithFormat:@"w%@s%@r%u",[choiceDict objectForKey:PPD_KEY_OPTION_WIDTH], [choiceDict objectForKey:PPD_KEY_OPTION_SURFACE], r];
//    }
//    matchedPaper = [[self unsortedPaper] objectForKey:paperKey];
//    return matchedPaper;
//}
//-(void)enableToneValues:(NSUInteger)tone
//{
//    NSPopUpButton * pbTone = [[self panelView] viewWithTag:kTPPDEPopupTagPaperTone];
//
//    //disable the popup when no tone options are available
//    [pbTone setEnabled:(BOOL)tone];
//
//    if(tone)
//    {
//        db("Enabling Tone for bits: %u", tone);
//        NSEnumerator * e = [[pbTone itemArray] objectEnumerator];
//        NSMenuItem * item = [e nextObject];
//        // the first object "Default" is always enabled
//        [item setEnabled:YES];
//        int i;
//        for( i=0 ; item = [e nextObject] ; i++ )
//        {
//            [item setEnabled: (1 << i) & tone ];        
//        }
//        // modify the selection if existing is now disabled
//        if( NO == [[pbTone selectedItem] isEnabled] )
//        {
//            i = [pbTone numberOfItems] ? 0 : -1;
//            [pbTone selectItemAtIndex:i];
//            [pbTone synchronizeTitleAndSelectedItem];
//            [self changePrinterSetting:pbTone];
//        }
//    }
//}
//-(NSUInteger)paperToneForStuff
//{
//    NSUInteger tone = 0; //default to zero
//    NSNumber * num = [[self match] objectForKey:@"paperTone"];
//    if(num)
//    {
//        tone = [num unsignedIntValue];
//    }
//    return tone;
//}
//-(void)didSelectNewPaper:(id)paper
//{
//    static NSString * cdDescription = nil;
//    if ([[choiceDict description] isEqualToString:cdDescription] || nil == [choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION])
//    {
//        // nothing has changed so sayonara
//        return;
//    }
//    [cdDescription release];
//    cdDescription = [[choiceDict description] retain];
////    NSPrintInfo * info = [NSPrintInfo sharedPrintInfo];
////    NSSize size = [info paperSize];
////    [info setPaperSize:size];
////    NSDictionary * matchedPaper = [self match];
//    //update all of the widgets that are dependent on paper selection
//    NSArray *rez = nil;
//    NSEnumerator * e;
//    NSPopUpButton * pbRez = [[self panelView] viewWithTag:kTPPDEPopupTagPaperResolution];
//    //NSPopUpButton * pbTone = [[self panelView] viewWithTag:kTPPDEPopupTagPaperTone];
//    NSString * key;
//    NSDictionary *d;
//    db("entering didSelectNewPaper with %u options %@", [choiceDict count], choiceDict);
//    if([[choiceDict objectForKey:PPD_KEY_OPTION_FEED] isEqualToString:PPD_KEY_CHOICE_SHEET])
//    {
//        if(nil == (key = [choiceDict objectForKey:PPD_KEY_OPTION_NAME]) && (key = [[[[self panelView] viewWithTag:kTPPDEPopupTagPaperName] selectedItem] representedObject]))
//        {
//            db("existing paper %@ is not a valid selection; changing %@",[choiceDict objectForKey:PPD_KEY_OPTION_NAME], key);
//                [pdePluginCallbackObject willChangePPDOptionKeyValue:PPD_KEY_OPTION_NAME ppdChoice: key];
//                [super setChoice:key forKey:PPD_KEY_OPTION_NAME];
//        }
//        ;//[[[self panelView] viewWithTag:kTPPDEPopupTagPaperName] title];//[[[[self panelView] viewWithTag:kTPPDEPopupTagPaperName] selectedItem] representedObject]
//        rez = [[_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_NAME] objectForKey:key];
//        // array holds valid resolutions for this paper name
//    }
//    else if(d = [_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_WIDTH])
//    {
//        NSString * width = [choiceDict objectForKey:PPD_KEY_OPTION_WIDTH];
//        if(nil == width)
//        {
//            //wait for the width to be set organically
//            return;
//        }
//        if(nil == (d = [d objectForKey:width]) && ((width = [[[[self panelView] viewWithTag:kTPPDEPopupTagPaperWidth] selectedItem] representedObject]) && (d = [[_sortedPaper objectForKey:TPPDE_NETORDER_PAPER_KEY_WIDTH] objectForKey:width])))
//        {
//            db("existing paper width of %@ is not a valid selection; changing width to %@",[choiceDict objectForKey:PPD_KEY_OPTION_WIDTH], width);
//                [pdePluginCallbackObject willChangePPDOptionKeyValue:PPD_KEY_OPTION_WIDTH ppdChoice: width];
//                [super setChoice:width forKey:PPD_KEY_OPTION_WIDTH];
//        }
//        // dict holds valid surfaces as keys to arrays of valid resolutions
//        NSArray * a = [d allKeys];
//        NSMatrix * m = [[self panelView] viewWithTag:kTPPDEMatrixTagSurface];
//        NSArray * cells = [m cells];
//        NSCell * c;
//        e = [cells objectEnumerator];
//        // disable the matrix cells that are representing unavailable surfaces
//        while(c = [e nextObject])
//        {
//            [c setEnabled:[a containsObject:[c title]]];
//        }
//        // modify the selection if existing is now disabled
//        if( NO == [[m selectedCell] isEnabled] )
//        {
//            if( [a count])
//            {
//                id choice = [a objectAtIndex:0];
//                [self updateControl:m withValue:choice];
//                [pdePluginCallbackObject willChangePPDOptionKeyValue:PPD_KEY_OPTION_SURFACE ppdChoice: choice];
//                [super setChoice:choice forKey:PPD_KEY_OPTION_SURFACE];
//                //[self markChoice:[a objectAtIndex:0] forPPDOptionKey:PPD_KEY_OPTION_SURFACE fromSender:m];
//            }
//        }
//        // now enable the resolutions
//        rez = [d objectForKey:[self newChoiceForSender:m]];
//    }
//    e = [[pbRez itemArray] objectEnumerator];
//    NSMenuItem * item;
//    while(item = [e nextObject])
//    {
//        [item setEnabled:[rez containsObject:[item title]]];        
//    }
//    //always enable 150dpi (the first menu item)
//    if( [pbRez numberOfItems] && NO==[PPD_KEY_CHOICE_SHEET isEqualToString:[choiceDict objectForKey:PPD_KEY_OPTION_FEED]])
//    {
//        [[pbRez itemAtIndex:0] setEnabled:YES];
//    }
//    
//    // modify the selection if existing is now disabled
//    if( rez && [choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION] && NO == [[pbRez selectedItem] isEnabled] )
//    {
//        [pbRez selectItemWithTitle:[rez objectAtIndex:0]];
//        [pbRez synchronizeTitleAndSelectedItem];
//        id choice = [self newChoiceForSender:pbRez];
//        //[self updateControl:pbRez withValue:choice];
//        [pdePluginCallbackObject willChangePPDOptionKeyValue:PPD_KEY_OPTION_RESOLUTION ppdChoice:choice];
//        [super setChoice:choice forKey:PPD_KEY_OPTION_RESOLUTION];
////        [self changePrinterSetting:pbRez];
////        [self markChoice:[rez objectAtIndex:0] forPPDOptionKey:PPD_KEY_OPTION_RESOLUTION fromSender:pbRez];
////        [self updateControl:pbRez withValue:[a objectAtIndex:0]];
//    }
////    e = [[pbTone itemArray] objectEnumerator];
////    item = [e nextObject];
////    // the first object "Default" is always enabled
////    [item setEnabled:YES];
////    NSUInteger tone = [self paperToneForStuff];
////    int i=0;
////    while(item = [e nextObject])
////    {
////        [item setEnabled: (1 << (i++)) == tone ];        
////    }
////    // modify the selection if existing is now disabled
////    if( NO == [[pbTone selectedItem] isEnabled] )
////    {
////        i = [pbTone numberOfItems] ? 0 : -1;
////        [pbTone selectItemAtIndex:i];
////        [pbTone synchronizeTitleAndSelectedItem];
////        [self changePrinterSetting:pbTone];
////    }
//}
//-(NSString *)defaultValueForOptionKey:(NSString *)optionKey
//{
//    NSString * choice;
//	NSPopUpButton * popup;
//    if( [optionKey isEqualToString:PPD_KEY_OPTION_NAME] && 0 < [popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperName] numberOfItems] )
//    {
//        choice = [[popup itemAtIndex:0] representedObject];
//    }
//    else
//    {
//        choice = [super defaultValueForOptionKey:optionKey];
//    }
//    return choice;
//}
//-(void)updateUI
//{
//    [super updateUI];
//    [self didSelectNewPaper:nil];
//}
//-(NSDictionary *)savedParsedPapers
//{
//    return [[self globalPrefsDictionary] objectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
//}
//-(void)saveParsedPaper:(id)paper
//{
//    [self saveToGlobalPrefsDictionaryValue:paper forKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
//    return;
//    NSMutableDictionary * mDict = [choiceDict objectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
//    if(nil == mDict)
//    {
//        mDict = [NSMutableDictionary dictionary];
//        NSDictionary * uDict = [[NSUserDefaults standardUserDefaults] objectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
//        if(uDict)
//        {
//            db( "about to add entries from global dictionary" );
//            db( "adding %u entries from global dictionary", [uDict count] );
//            NSEnumerator * e = [[uDict allKeys] objectEnumerator];
//            NSString * key;
//            id val;
//            while (key = [e nextObject])
//            {
//                val = [uDict objectForKey:key];
//                db( "adding val for key %@", key );
//                db( "val: ");
//                db( "%@", val );
//                //[mDict setObject:val forKey:key];
//            }
//            //[mDict addEntriesFromDictionary:uDict];
//        }
//        [choiceDict setObject:mDict forKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
//        db( "sorted papers: ");
//        db( "sorted papers %@", mDict );
//        db( "sorted papers2 %@", [choiceDict objectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED] );
//    }
//    if(paper)
//    {
//        [mDict setObject:paper forKey:(id)[self printerDeviceURI]];
//    }
//    db( "before setGlobalDefaultsObject retain count of dict is %u",[mDict retainCount]);
//    [self setGlobalDefaultsObject:mDict forKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
//    db( "after setGlobalDefaultsObject retain count of dict is %u",[mDict retainCount]);
//}
//-(void)setSortedPaper:(id)paper
//{
//    if( NO == [paper isEqual:_sortedPaper] )
//    {
//        paper = [paper retain];
//        [_sortedPaper release];
//        _sortedPaper = paper;
//        if(paper)
//        {
//            //test again for paper != nil so we never wipe out existing papers when we get nil paper
//            [self updatePaperUI];
//            [self saveParsedPaper:paper];
//        }
//    }
//}
//-(void)updatePaperInfo:(id)object
//{
//    //[self speakString:@"updating paper info"];
//    db( "received new paper dictionary" );
//    NSDictionary * unsortedPaper = [self unsortedPaper];
//    db( "paper count is %u", [unsortedPaper count] );
//    NSArray *sortedKeys = [[unsortedPaper allKeys] sortedArrayUsingSelector:@selector(numericalCaseInsensitiveCompare:)];
//    db( "%@", sortedKeys );
//    [self speakString:[NSString stringWithFormat:@"%u NetOrder registered paper%s", [unsortedPaper count], 1 == [unsortedPaper count] ? "" : "s"]];
//    NSView * view = [self panelView];
//    
//    NSPopUpButton * paperWidths = [view viewWithTag: kTPPDEPopupTagPaperWidth];
//    NSPopUpButton * paperNames = [view viewWithTag: kTPPDEPopupTagPaperName];
//    NSString * title;
//    NSString * key;
//    NSDictionary * aPaper;
//    
//    NSEnumerator * e = [sortedKeys objectEnumerator];
//
//    [paperNames removeAllItems];
//    [paperWidths removeAllItems];
//
//    NSMutableArray * rez;
//    NSUInteger tone = 0;
//    NSMutableDictionary * surface;
//    NSMutableDictionary * mUIPaperNames = [[NSMutableDictionary alloc] init];
//    NSMutableDictionary * mUIPaperWidths = [[NSMutableDictionary alloc] init];
//    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
//    NSAutoreleasePool *pool2 = nil;
//    for( ; key = [e nextObject] ; [pool2 drain])
//    {
//        pool2 = [[NSAutoreleasePool alloc] init];
//        aPaper = [unsortedPaper objectForKey:key];
//        tone |= [[aPaper objectForKey:@"paperTone"] unsignedIntValue];
//        rez = nil;
//        if( (title = [aPaper objectForKey:@"paperName"]) && [title length] )
//        {
//            [paperNames addItemWithTitle:title];
//            [[paperNames lastItem] setRepresentedObject:title];
//            [[paperNames lastItem] setTag:kTPPDEPopupTagPaperName];
//            if( nil == ( rez = [mUIPaperNames objectForKey:title] ) )
//            {
//                rez = [NSMutableArray array];
//                [mUIPaperNames setObject:rez forKey:title];
//            }
//        }
//        else if( ( title = [[aPaper objectForKey:@"paperWidth"] stringValue]) && [title length] )
//        {            
//            [paperWidths addItemWithTitle:[self humanReadablePaperWidthForActual:title]];
//            [[paperWidths lastItem] setRepresentedObject:title];
//            [[paperWidths lastItem] setTag:kTPPDEPopupTagPaperWidth];
//            if( nil == ( surface = [mUIPaperWidths objectForKey:title] ) )
//            {
//                surface = [NSMutableDictionary dictionary];
//                [mUIPaperWidths setObject:surface forKey:title];
//            }
//            if( nil == ( rez = [surface objectForKey:(title = [[aPaper objectForKey:@"paperSurface"] stringValue] )] ) )
//            {
//                rez = [NSMutableArray array];
//                [surface setObject:rez forKey:title];
//            }
//        }
//        else
//        {
//            db( "bad paper: %@", aPaper );
//            continue;
//        }
//        if( ( title = [NSString stringWithFormat:@"%d dpi", [[aPaper objectForKey:@"paperResolution"] intValue] / 10] ) && ! [rez containsObject:title] )
//        {
//            [rez addObject: title];
//        }
//    }
//    [pool drain];
//    NSDictionary * sortedPapers = [[NSDictionary alloc] initWithObjectsAndKeys: mUIPaperNames, TPPDE_NETORDER_PAPER_KEY_NAME, mUIPaperWidths, TPPDE_NETORDER_PAPER_KEY_WIDTH, nil];
//    [self setSortedPaper:sortedPapers];
//    [self enableToneValues:tone];
//    [sortedPapers release];
//    [mUIPaperNames release];
//    [mUIPaperWidths release];
//    [self restoreValuesAndReturnError:nil];
////    db("%@",_sortedPaper);
////    NSDictionary * settings = nil;
////    PMPrintSettingsCopyAsDictionary((PMPrintSettings)[pdePluginCallbackObject printSettings], &(CFDictionaryRef)settings);
////    NSLog(@"Print settings:%@",[settings autorelease]);
////    PMPrinter printer = (PMPrinter)[pdePluginCallbackObject PMPrinter];
////    NSArray * paperList;
////    OSStatus err = PMPrinterGetPaperList((PMPrinter)[pdePluginCallbackObject PMPrinter], &(CFArrayRef)paperList);
////    paperList = [paperList retain];
////    NSLog(@"Paper list:%@",err ? nil : paperList);
////    [paperList release];
////    PMPageFormat pageFormat = (PMPageFormat)[pdePluginCallbackObject pageFormat];
////    [paperNames selectItemAtIndex:0];
////    [paperWidths selectItemAtIndex:0];
////
////    [paperNames synchronizeTitleAndSelectedItem];
////    [paperWidths synchronizeTitleAndSelectedItem];
//
////    [popup selectItemAtIndex:[popup indexOfItemWithRepresentedObject:[NSString stringWithUTF8String:option->defchoice]]];
//}
//-(void)waitForNoritsuPaper:(id)object
//{
//    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
//    [NoritsuNetorderJob registerNewThread:[NSThread currentThread]];
//    if([[NSGarbageCollector defaultCollector] isEnabled])
//    {
//        [self speakString:[NSString stringWithFormat:@"Garbage collection is enabled in %@",[[NSProcessInfo processInfo] processName]]];
//    }
//    self = [self retain];
//    NSUInteger retainCount = [self retainCount];
//    if(pool)
//    {
//       [self setUnsortedPaper:[[NoritsuNetorderJob papersForDeviceURI:(NSString *)[self printerDeviceURI] onlyInstalled:YES] retain]];
////        [NSThread  sleepForTimeInterval:5];
////        [self setDuplexEnabled:NO];
//        
//        if( [self retainCount] >= retainCount )
//        {
//            if([[self unsortedPaper] count])
//            {
//                [self speakString:[NSString stringWithFormat:@"%u NetOrder registered paper%s", [[self unsortedPaper] count], 1 == [[self unsortedPaper] count] ? "" : "s"]];
//                [self performSelectorOnMainThread:@selector(updatePaperInfo:) withObject:[self unsortedPaper] waitUntilDone:YES];
//            }
//            else
//            {
//                [self speakString:@"Failed to update the NetOrder papers"];
//            }
//        }
//    }
//    [self release];
//    [pool drain];
//}
//-(void)updatePaperAsync:(id)object
//{
//    NSString *uri = (NSString *)[self printerDeviceURI];
//    [ATMPPR_CUPSPrintJob setLogFile:[self logfile]];
//    db("updating paper for %@",uri);
//    _waitingOnPaper = YES;
//    NSDictionary * dict = [[NoritsuNetorderJob papersForDeviceURI:uri onlyInstalled:NO] retain];
//    if(_waitingOnPaper && [dict count])
//    {
//        [self setUnsortedPaper:dict];
//        [self updatePaperInfo:nil];
//    }
//    _waitingOnPaper = NO;
//}
//-(void)newPaperDict:(NSNotification *)note
//{
//    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
//    NSDictionary *allPapers = [note userInfo];
//    db( "PDE received %u NetOrder Papers",[allPapers count] );
//    NoritsuNetorderJob * tempJob = [choiceDict objectForKey:@"NoritsuNetorderJob"];
//    if([allPapers count])
//    {
//        [self setUnsortedPaper:allPapers];
//        [self updatePaperInfo:nil];
//    }
//    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"netorderPaperDidUpdate" object:nil];
//    db( "before removing from choiceDict retain count of tempJob is %u",[tempJob retainCount]);
//    [choiceDict removeObjectForKey:@"NoritsuNetorderJob"];
//    db( "after removing from choiceDict retain count of tempJob is %u",[[choiceDict objectForKey:@"NoritsuNetorderJob"] retainCount]);
//    [pool drain];
//}
//-(void)setBindingWidthAvailable
//{
//    BOOL enabled = [[[self panelView] viewWithTag:kTPPDEPopupTagBindingMargin] isEnabled] && NO == [[self printSystemValueForKey:PPD_KEY_OPTION_BINDMARGIN] isEqualToString:PPD_KEY_CHOICE_NONE];
//    [[[self panelView] viewWithTag:kTPPDEStepperTagBindingWidth] setEnabled:enabled];
//    [[[self panelView] viewWithTag:kTPPDEStepperTagBindingWidth | kTPPDEControlValueMask] setEnabled:enabled];
//}
//-(void)setBindingMarginAvailable
//{
//    BOOL enabled = [[[self panelView] viewWithTag:kTPPDEPopupTagTwoSided] isEnabled] && NO == [[self printSystemValueForKey:PPD_KEY_OPTION_TWO_SIDED] isEqualToString:PPD_KEY_CHOICE_NONE];
//    [[[self panelView] viewWithTag:kTPPDEPopupTagBindingMargin] setEnabled:enabled];
//    [self setBindingWidthAvailable];
//    [self didSelectTwoSided:nil];
//}
//-(void)setDuplexAvailable
//{
//    BOOL canDuplex = [[self printSystemValueForKey:PPD_KEY_OPTION_FEED] isEqualToString:PPD_KEY_CHOICE_SHEET] && [self hardwareSupportsDuplex];
//    [[[self panelView] viewWithTag:kTPPDEPopupTagTwoSided] setEnabled:canDuplex];
//    if( NO == canDuplex && NO == [[self printSystemValueForKey:PPD_KEY_OPTION_TWO_SIDED] isEqualToString:PPD_KEY_CHOICE_NONE] )
//    {
//        [pdePluginCallbackObject willChangePPDOptionKeyValue:PPD_KEY_OPTION_TWO_SIDED ppdChoice: PPD_KEY_CHOICE_NONE];
//        [super setChoice:PPD_KEY_CHOICE_NONE forKey:PPD_KEY_OPTION_TWO_SIDED];
//        [self updateControl:[[self panelView] viewWithTag:kTPPDEPopupTagTwoSided] withValue:PPD_KEY_CHOICE_NONE];
//    }
//    [self setBindingMarginAvailable];
//}
//-(BOOL)hardwareSupportsDuplex
//{
//    return [[choiceDict objectForKey:@"netorderHardwareSupportsDuplex"] boolValue];
//}
//-(void)setHardwareSupportsDuplex:(BOOL)flag
//{
//    [choiceDict setObject:[NSNumber numberWithBool:flag] forKey:@"netorderHardwareSupportsDuplex"]; 
//    db( "Setting Duplex capability ... this printer %s duplex",flag ? "CAN" : "CANNOT" );
//    [self saveToGlobalPrefsDictionaryValue:[NSNumber numberWithBool:flag] forKey:@"netorderHardwareSupportsDuplex"];       
//    [self setDuplexAvailable];
//}
//-(void)setSupportsSheet
//{
//    BOOL supportsSheet = [self hardwareSupportsExtraFeatures];
//    NSView * view = [self panelView];
//    NSPopUpButton * p = [view viewWithTag: kTPPDEPopupTagPaperFeed];
//    NSMenuItem * item = [p itemAtIndex:[p indexOfItemWithRepresentedObject:PPD_KEY_CHOICE_SHEET]];
//    [item setEnabled:supportsSheet];
//    if(NO == supportsSheet)
//    {
//        db("This printer does not support sheet printing");
//        [self markChoice:PPD_KEY_CHOICE_ROLL forPPDOptionKey:PPD_KEY_OPTION_FEED fromSender:[[self panelView] viewWithTag: kTPPDEPopupTagPaperFeed]];
//    }
//}
//-(BOOL)hardwareSupportsExtraFeatures
//{
//    return [[choiceDict objectForKey:@"netorderHardwareSupportsExtraFeatures"] boolValue];
//}
//-(void)setHardwareSupportsExtraFeatures:(BOOL)flag
//{
//    [choiceDict setObject:[NSNumber numberWithBool:flag] forKey:@"netorderHardwareSupportsExtraFeatures"]; 
//    db( "Setting Features capability ... this printer does %shave extra features.",flag ? "" : "NOT " );
//    [self saveToGlobalPrefsDictionaryValue:[NSNumber numberWithBool:flag] forKey:@"netorderHardwareSupportsExtraFeatures"];
//    [self setSupportsSheet];
//}
//-(void)newPrinterInfo:(NSNotification *)note
//{
//    NoritsuNetorderJob * tempJob = [choiceDict objectForKey:@"NoritsuNetorderJob"];
//    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"netorderPrinterInfoDidUpdate" object:nil];
//    [self setHardwareSupportsDuplex:[tempJob canDuplex]];
//    [self setHardwareSupportsExtraFeatures:[tempJob extraFeatures]];
//    db( "received NetOrder Printer Info ... this printer %s duplex",[tempJob canDuplex] ? "CAN" : "CANNOT" );
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(newPaperDict:) name:@"netorderPaperDidUpdate" object:nil];
//    db( "getting printer papers" );
//    [tempJob getRegisteredPapersAsync];
//}
//-(void)startPaperUpdating
//{
//    NoritsuNetorderJob * tempJob = [choiceDict objectForKey:@"NoritsuNetorderJob"];
//    if( nil == tempJob)
//    {
//        db( "allocating NetOrder object" );
//        NSString * printerDeviceURI = (NSString *)[self printerDeviceURI];
//        tempJob = [[NoritsuNetorderJob alloc] initWithDeviceURI:printerDeviceURI];
//        if(tempJob)
//        {
//            [tempJob setShouldStartRunLoop:NO];
//            [super setChoice:@"" forKey:@"NoritsuNetorderJob"];
//            [choiceDict setObject:tempJob forKey:@"NoritsuNetorderJob"];
//            [tempJob release];
//        }
//    }
//    else
//    {
//        db( "reusing NetOrder object" );
//        [[NSNotificationCenter defaultCenter] removeObserver:self name:@"netorderPrinterInfoDidUpdate" object:nil];
//        [[NSNotificationCenter defaultCenter] removeObserver:self name:@"netorderPaperDidUpdate" object:nil];
//        [[NSNotificationCenter defaultCenter] removeObserver:self name:@"NetOrderPrinterAsyncOperationDidAbort" object:nil];
//        [tempJob cleanupAfterAsync];
//    }
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(newPrinterInfo:) name:@"netorderPrinterInfoDidUpdate" object:nil];
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(asyncOpAborted:) name:@"NetOrderPrinterAsyncOperationDidAbort" object:nil];
//    [tempJob getInfoAsync];    
//
//}
//-(void)asyncOpAborted:(NSNotification *)note
//{
//    static NSTimeInterval delay = 1.0;
//    //back off to a point ...
//    if(120 > delay)
//    {
//        delay *= 2;
//    }
//    db( "the asynchronous operation has aborted. Restarting after delay ... %.0f",delay );    
//    [self performSelector:@selector(startPaperUpdating) withObject:nil afterDelay: delay];
//}
//-(void)noteLog:(NSNotification *)note
//{
//    NSString * name = [note name];
//    if([name hasPrefix:@"NSWindow"] || [name hasPrefix:@"NSMenu"] || [name hasPrefix:@"NSApplication"] || [name hasPrefix:@"_NSWindow"] || [name hasPrefix:@"NSView"] );
//    else
//    {
//        db( "new notification: %@", note );
//    }
//}
//-(void)printInfoDidChange:(NSNotification *)note
//{
//    //[self setChoice:[choiceDict objectForKey:PPD_KEY_OPTION_BINDMARGIN] forKey:PPD_KEY_OPTION_BINDMARGIN];
//    [self didSelectTwoSided:note];
//}
//#pragma mark -
//#pragma mark init and dealloc
//-(id)initWithCallback:(id)callback 
//{
//    if(self = [super initWithCallback:callback])
//    {
//        db("initializing the printer features object with cb %@",callback);
//        [ATMPPR_CUPSPrintJob setShouldLogAppName:YES];
//        [ATMPPR_CUPSPrintJob setLogFile:[self logfile]];
//        //[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(noteLog:) name:nil object:nil];
//        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(printInfoDidChange:) name:@"NSPrintInfoDidChange" object:nil];
//        paperDict = nil;
//        _sortedPaper = nil;
//        _waitingOnPaper = NO;
//        _firstRun = 0;
//        NSDictionary * gp = [self globalPrefsDictionary];
////        _sortedPaper = [[[NSUserDefaults standardUserDefaults] objectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED] objectForKey:(id)[self printerDeviceURI]];
//        if(gp)
//        {
//            db( "using globabls prefs: %@", gp );
//            NSNumber * nilValue = [NSNumber numberWithBool:NO];
//            [choiceDict setObject:[gp objectForKey:@"netorderHardwareSupportsDuplex"]?:nilValue  forKey:@"netorderHardwareSupportsDuplex"];
//            [choiceDict setObject:[gp objectForKey:@"netorderHardwareSupportsExtraFeatures"]?:nilValue  forKey:@"netorderHardwareSupportsExtraFeatures"];
//            [self setDuplexAvailable];
//            _sortedPaper = [[gp objectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED] retain];
//            [self updatePaperUI];
//        }
//        [self startPaperUpdating];
//        
////        [self setSortedPaper:];
//        //"com.apple.print.PrintSettings.PMDuplexing" = 1
////        "com.apple.print.subTicket.paper_info_ticket" =     {
////        PMPPDPaperCodeName = Custom;
////        PMPPDTranslationStringPaperName = Custom;
////        PMTiogaPaperName = Custom;
////        "com.apple.print.PaperInfo.PMConstrainedPaper" = 0;
////        "com.apple.print.PaperInfo.PMPaperName" = Custom;
////        "com.apple.print.PaperInfo.PMUnadjustedPageRect" =         (
////            0,
////            0,
////            432,
////            288
////        );
////        "com.apple.print.PaperInfo.PMUnadjustedPaperRect" =         (
////            0,
////            -0,
////            432,
////            288
////        );
////        "com.apple.print.PaperInfo.ppd.PMPaperName" = Custom;
////        "com.apple.print.ticket.type" = "com.apple.print.PaperInfoTicket";
////    }
//            // init all of the NetOrder paper values obtained from the printer
////        [NoritsuNetorderJob newThreadForSelector:@selector(waitForNoritsuPaper:) toTarget:self withObject:nil];
////        [self performSelector:@selector(updatePaperAsync:) withObject:nil afterDelay:0.1];
//        [self restoreValuesAndReturnError:nil];
//    }
//    return self;
//}
//- (void) dealloc
//{
//    [NSObject cancelPreviousPerformRequestsWithTarget:self];
//
//    //    NSString *btrace = [[self class] backtrace:20];
////    NSLog(btrace);
////    NSString * tempFile = [NSString stringWithFormat:@"/tmp/noritsuBacktrace%p.txt",[NSThread currentThread]];
////    [btrace writeToFile:tempFile atomically:NO encoding:NSUTF8StringEncoding error:NULL];
////    [[NSWorkspace sharedWorkspace] openFile:tempFile];
//    [[NSNotificationCenter defaultCenter] removeObserver:self];
//    // if we still have an outstanding async job then clean it up 
//    NoritsuNetorderJob * tempJob = [choiceDict objectForKey:@"NoritsuNetorderJob"];
//    db( "about to release choiceDict" );
//    db( "choiceDict keys:%@", [choiceDict allKeys] );
//    [tempJob cleanupAfterAsync];
//    [choiceDict removeObjectForKey:@"NoritsuNetorderJob"];
//    [choiceDict removeObjectForKey:TPPDE_NETORDER_PAPER_KEY_CACHED];
////    if(_waitingOnPaper)
////    {
////        CFRunLoopStop(CFRunLoopGetCurrent());
////        _waitingOnPaper = NO;
////    }
//    [paperDict release];
//    paperDict = nil;
//    [self speakString:@"Goodbye."];
//    db( "about to release choiceDict" );
//    db( "choiceDict values:%@", [choiceDict allValues] );
//    [super dealloc];
//}
//- (void)willShow
//{
//    [self speakString:@"Choose the NetOrder paper and printing opp-shuns."];
////    [self didSelectNewPaper:nil];
//
////    NSLog ( @"will show features");
////    NSDictionary * settings = nil;
////    NSString * tempFile = @"/tmp/printSettings.plist";
////    PMPrintSettingsCopyAsDictionary((PMPrintSettings)[pdePluginCallbackObject printSettings], &(CFDictionaryRef)settings);
////    [[settings autorelease] writeToFile:tempFile atomically:NO];
////    [[NSWorkspace sharedWorkspace] openFile:tempFile];
//}
//-(NSView *)panelView
//{
//    id v, i;
//	if (nil == _panelView)
//    {
//        v = [super panelView];
//        NSEnumerator *e = [[[v viewWithTag:kTPPDEPopupTagPaperResolution] itemArray] objectEnumerator];
//        while (i = [e nextObject])
//        {
//            [i setTag:kTPPDEPopupTagPaperResolution];
//        }
//        [[v viewWithTag:kTPPDEPopupTagPaperTone] setEnabled:YES];
//        [[v viewWithTag:kTPPDEPopupTagPaperResolution] setAutoenablesItems:NO];
//        [[v viewWithTag:kTPPDEPopupTagPaperWidth] setAutoenablesItems:NO];
//        [[v viewWithTag:kTPPDEPopupTagPaperName] setAutoenablesItems:NO];
//        [[v viewWithTag:kTPPDEPopupTagPaperFeed] setAutoenablesItems:NO];
//        [[v viewWithTag:kTPPDEPopupTagPaperTone] setAutoenablesItems:NO];
//        [[v viewWithTag:kTPPDEPopupTagTwoSided] setAutoenablesItems:NO];
//        [[v viewWithTag:kTPPDEPopupTagBindingMargin] setAutoenablesItems:NO];
//        db( "about to updatePaperUI" );
//        [self updatePaperUI];
//        db( "done with updatePaperUI" );
//    }
//    return _panelView;
//}
//- (NSString*)nibName
//{
//	return @"NetOrderFeatures";
//}
//
//// Return the localized name for this PDE. This will be used as its title in the
//// menu of printing panes.
//- (NSString*)panelName
//{
//	if (nil == thePDEName){
//		thePDEName = [ [ pdeBundle localizedStringForKey:TPPDE_PPD_PANEL_NAME_KEY_FEATURES value:nil table:nil] retain ];
//	}
//	
//	return thePDEName;
//}
//
//// return the kind ID for this PDE
//- (NSString*)panelKind
//{
//	return TPPDE_PPD_PANEL_KIND_ID_FEATURES;
//}
//- (NSString *) ppdOptionKeyForTag:(int)tag
//{
//	NSString *key=nil;
//    if(tag & kTPPDEControlValueMask)
//    {
//        tag ^= kTPPDEControlValueMask;
//    }
//
//	switch(tag)
//	{
//		case kTPPDEPopupTagPaperWidth:
//			key = PPD_KEY_OPTION_WIDTH;
//			break;
//		case kTPPDEMatrixTagSurface:
//			key = PPD_KEY_OPTION_SURFACE;
//			break;
//		case kTPPDEStepperTagOverspill:
//			key = PPD_KEY_OPTION_OVERSPILL;
//			break;
//		case kTPPDEPopupTagPaperResolution:
//			key = PPD_KEY_OPTION_RESOLUTION;
//			break;
//		case kTPPDEPopupTagPaperTone:
//			key = PPD_KEY_OPTION_TONE;
//			break;
//		case kTPPDEPopupTagPaperFeed:
//			key = PPD_KEY_OPTION_FEED;
//			break;
//		case kTPPDEPopupTagPaperName:
//			key = PPD_KEY_OPTION_NAME;
//			break;
//		case kTPPDEPopupTagBindingMargin:
//			key = PPD_KEY_OPTION_BINDMARGIN;
//			break;
//		case kTPPDEStepperTagBindingWidth:
//			key = PPD_KEY_OPTION_BINDWIDTH;
//			break;
//		case kTPPDEPopupTagTwoSided:
//			key = PPD_KEY_OPTION_TWO_SIDED;
//			break;
//		default:
//			break;
//	}
//	return key;
//}
////-(BOOL)markChoice:(NSString *)choice forPPDOptionKey:(NSString *)ppdOptionKey fromSender:(id)sender
////{
////    if([ppdOptionKey isEqualToString:PPD_KEY_OPTION_RESOLUTION] && NSFoundationVersionNumber10_5_MAX > NSFoundationVersionNumber)
////    {
////        // work around out-of-bounds bug where print system doesn't know how to follow instructions
////        // may be fixed in some distant future; the fix may break this workaround code.
////        // By order of the BUG, the selected resolution must be 50 points higher than any other available resolution
////        // example 1: (150,300,320,360,400,500); user selects 320 but we must set at least 350 (300 + 50) to
////        // avoid the print system deciding that 300 is "close enough"
////        NSInteger resolution = [choice intValue];
////        NSInteger appleResolution = resolution;
////        NSInteger someResolution;
////        NSInteger i;
////        NSString * otherChoice;
////        ppd_option_t * option = ppdFindOption(ppd, [ppdOptionKey UTF8String]);
////        BOOL accepted = NO;
////        if(option)
////        {
////            for(i = 0; option->num_choices > i ; ++i)
////            {
////                otherChoice=[NSString stringWithUTF8String:option->choices[i].choice];
////                someResolution = [otherChoice intValue];
////                if (someResolution < resolution && someResolution + 50 > appleResolution)
////                {
////                    appleResolution = someResolution + 50;
////                } 
////            }
////            if(appleResolution != resolution)
////            {
////                otherChoice = [NSString stringWithFormat:@"%ddpi",appleResolution];
////                if(otherChoice && (accepted=[pdePluginCallbackObject willChangePPDOptionKeyValue:ppdOptionKey ppdChoice: otherChoice]))
////                {
////                    //mark the modified choice
////                    // but set the original choice value
////                    [self setChoice:choice forKey:ppdOptionKey];
////                    return accepted;
////                }
////            }
////        }
////    }
////    return [super markChoice:choice forPPDOptionKey:ppdOptionKey fromSender:sender];
////}
////- (void) setChoice:(NSString *)choice forKey:(NSString *)ppdOptionKey
////{
////    if(useConstraintHandling && [ppdOptionKey isEqualToString:PPD_KEY_OPTION_RESOLUTION] && NSFoundationVersionNumber10_5_MAX > NSFoundationVersionNumber)
////    {
////        // work around out-of-bounds bug where print system doesn't know how to follow instructions
////        // may be fixed in some distant future; the fix may break this workaround code.
////        // By order of the BUG, the selected resolution must be 50 points higher than any other available resolution
////        // example 1: (150,300,320,360,400,500); user selects 320 but we must set at least 350 (300 + 50) to
////        // avoid the print system deciding that 300 is "close enough"
////        NSInteger resolution = [choice intValue];
////        NSInteger appleResolution = resolution;
////        NSInteger someResolution;
////        NSInteger i;
////        NSString * otherChoice;
////        ppd_option_t * option = ppdFindOption(ppd, [ppdOptionKey UTF8String]);
////        if(option)
////        {
////            for(i = 0; option->num_choices > i ; ++i)
////            {
////                otherChoice=[NSString stringWithUTF8String:option->choices[i].choice];
////                someResolution = [otherChoice intValue];
////                if (otherChoice && someResolution < resolution && someResolution + 50 > appleResolution)
////                {
////                    appleResolution = someResolution + 50;
////                } 
////            }
////            if(appleResolution != resolution)
////            {
////                otherChoice = [NSString stringWithFormat:@"%ddpi",appleResolution];
////                if(otherChoice)
////                {
////                    [pdePluginCallbackObject willChangePPDOptionKeyValue:ppdOptionKey ppdChoice: otherChoice];
////                }
////            }
////        }
////    }
////    [super setChoice:choice forKey:ppdOptionKey];
////}
//-(void)setToolTip:(id)value fromSender:(id)sender
//{
//	[sender setToolTip:@""];
//}
//- (void)controlTextDidEndEditing:(NSNotification *)aNotification
//{
//    if([[[aNotification object] stringValue] isEqualToString:@"-"])
//    {
//        [[aNotification object] setStringValue:@"0"];
//    }
//    [self changePrinterSetting:[aNotification object]];
//}
//- (void)controlTextDidChange:(NSNotification *)aNotification
//{
////    NSLog(@"%@",aNotification);
////    [self changePrinterSetting:[aNotification object]];
//}
//- (BOOL)saveValuesAndReturnError:(NSError **)error
//{
//    [super saveValuesAndReturnError:error];
//    
//    PMPrintSettings settings = (PMPrintSettings)[pdePluginCallbackObject printSettings];
//    OSStatus err;
//	if(settings && useConstraintHandling)
//	{
//        NSArray * nonPPDKeys = [NSArray arrayWithObjects:
//            PPD_KEY_OPTION_NAME,
//            PPD_KEY_OPTION_BINDWIDTH,
//            PPD_KEY_OPTION_OVERSPILL,
//            PPD_KEY_OPTION_PAPER_INFO_TICKET,
//            PPD_KEY_OPTION_LAST_REZ,
//            nil];
//
//		NSString *value=nil;
//		NSEnumerator * e = [nonPPDKeys objectEnumerator];
//		NSString * optionKey;
//		while (optionKey=[e nextObject])
//		{
//            value = [choiceDict objectForKey:optionKey];
//            if([optionKey isEqualToString:PPD_KEY_OPTION_LAST_REZ])
//            {
//                value = [choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION];
//            }
//            if(value)
//            {
//                err = PMPrintSettingsSetValue(settings, (CFStringRef)optionKey, (CFTypeRef)value, kPMUnlocked);
//                // do appropriate thing when there is an error. Here we write it
//                if(err)
//                {
//                    NSLog(@"PDE got an error %d setting the value for %@ !", err, optionKey);
//                }
//            }
//        }
//    }
//
//	return YES;
//}
//- (BOOL)restoreValuesAndReturnError:(NSError **)error
//{
////    static int timesThru = 0;
////    timesThru++;
////    db("entering %s for the %dth (%d) time (%@, %@)", __func__, timesThru, _firstRun, [choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION], [choiceDict objectForKey:PPD_KEY_OPTION_LAST_REZ]);
//    BOOL r = [super restoreValuesAndReturnError:error];
//    if(0==_firstRun && [choiceDict objectForKey:PPD_KEY_OPTION_LAST_REZ] && [choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION] && NO == [[choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION] isEqualToString:[choiceDict objectForKey:PPD_KEY_OPTION_LAST_REZ]])
//    {
//        _firstRun++;
//        db("saved resolution differs from system value; restoring %@ to %@",[choiceDict objectForKey:PPD_KEY_OPTION_RESOLUTION], [choiceDict objectForKey:PPD_KEY_OPTION_LAST_REZ]);
//        [self markChoice:[choiceDict objectForKey:PPD_KEY_OPTION_LAST_REZ] forPPDOptionKey:PPD_KEY_OPTION_RESOLUTION fromSender:[[self panelView] viewWithTag: kTPPDEPopupTagPaperResolution]];
//    }
//    [self didSelectNewPaper:nil];
//    [self setDuplexAvailable];
//    [self didSelectTwoSided:nil];
//    return r;
//}
////	PMPrintSettings settings = (PMPrintSettings)[pdePluginCallbackObject printSettings];
////	if(settings && useConstraintHandling)
////	{
////        NSArray * nonPPDKeys = [NSArray arrayWithObjects:
////            PPD_KEY_OPTION_NAME,
////            nil];
////
////		NSEnumerator * e = [nonPPDKeys objectEnumerator];
////		NSString *choice=nil;
////		NSString * key;
////		while (key = [e nextObject])
////		{
////            if( PMPrintSettingsGetValue(settings, (CFStringRef)key, (CFTypeRef *)&choice) )
////            {
////                // No setting in the job ticket for this key, so try a default value.
////                choice = [self defaultValueForOptionKey:key] ? : @"";
////            }
////            [self setChoice:choice forKey:key];
////		}
////	}
////	// Now have UI reflect the current settings.
////	[self updateUI];
////		
////	return YES;
////}
//-(id)newChoiceForSender:(id)sender
//{
//    NSString *choice;
//    NSInteger tag = [sender tag];
//    if(tag  == kTPPDEStepperTagOverspill || tag == kTPPDEStepperTagBindingWidth || 83 == tag || 89 == tag)
//    {
//        choice = [self floatValueForSender:sender format:@"%.1f" allowsNegative:NO];
//    }
//    else if([sender isKindOfClass:[NSPopUpButton class]])
//    {
//        switch (tag)
//        {
//        case kTPPDEPopupTagBindingMargin:
//            choice = [self bindingMarginForMargin:[[sender selectedItem] representedObject] reverse:NO];
//            break;
//        case kTPPDEPopupTagPaperWidth:
//        case kTPPDEPopupTagPaperName:
////            choice = [[sender selectedItem] title];
////            break;
//        default:
//            choice = [[sender selectedItem] representedObject];
//            break;
//        }
//    }
//    else if([sender isKindOfClass:[NSMatrix class]])
//    {
//        NSInteger tag = 0;
//        if([sender respondsToSelector:@selector(selectedCell)])
//        {
//            tag = [[sender selectedCell] tag];
//        }
//        else if([sender respondsToSelector:@selector(tag)])
//        {
//            tag = [sender tag];
//        }
//        choice =  [self ppdChoiceForTag:tag];
//    }
//    else
//    {
//        choice = [sender stringValue];
//    }
//
//    return choice;
//}
//- (void) setChoice:(NSString *)choice forKey:(NSString *)key
//{
//    if( [choice isEqualToString:PPD_KEY_CHOICE_SHEET] && NO == [self hardwareSupportsExtraFeatures] )
//    {
//        [self setSupportsSheet];
//        return;
//        //verify that the printer supports sheet
//        
//    }
//
//    if ( [choice isEqualToString:[choiceDict objectForKey:key]] )
//    {
//        return;
//    }
//    [super setChoice:choice forKey:key];
//    
////    if([key isEqualToString:PPD_KEY_OPTION_FEED_FAKE])
////    {
////        // keep real in sync with fake value to work around a bug in (at least) Mac OS X version 10.5.6
////        [self markChoice:choice forPPDOptionKey:PPD_KEY_OPTION_FEED fromSender:nil];
////        [self didSelectNewPaper:nil];
////
////    } else
//    if([key isEqualToString:PPD_KEY_OPTION_FEED])
//    {
//        db("setting %@ to %@",key,choice);
////        // set the fake value to work around a bug in (at least) Mac OS X version 10.5.6
////        if( NO == [choice isEqualToString:[choiceDict objectForKey:PPD_KEY_OPTION_FEED_FAKE]] )
////        {
////            if( [pdePluginCallbackObject willChangePPDOptionKeyValue:PPD_KEY_OPTION_FEED_FAKE ppdChoice: choice])
////            {
////                [choiceDict setObject:choice forKey:PPD_KEY_OPTION_FEED_FAKE];
////            }
////            else
////            {
////                ppd_choice_t * ppdChoice = ppdFindMarkedChoice(ppd, [PPD_KEY_OPTION_FEED_FAKE UTF8String]);
////                [self updateControl:[[self panelView] viewWithTag:kTPPDEPopupTagPaperFeed] withValue:[NSString stringWithUTF8String:ppdChoice->choice]];
////            }
////            [self didSelectNewPaper:nil];
////        }
////
//        BOOL isEnabled = YES;
////        NSPopUpButton * popup = nil;
//        if([choice isEqualToString:PPD_KEY_CHOICE_SHEET])
//        {
//            isEnabled = NO;
//            
//
////            if( [(popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperWidth]) respondsToSelector:@selector(selectItemAtIndex:)] )
////            {
////                [popup selectItemAtIndex:-1];
////            }
////            if( [(popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperName]) respondsToSelector:@selector(selectItemAtIndex:)] )
////            {
////                [popup selectItemAtIndex:[self indexOfMenuItem:popup forValue:[choiceDict objectForKey:PPD_KEY_OPTION_NAME]]];
////            }
//        }
//        else if([choice isEqualToString:PPD_KEY_CHOICE_ROLL])
//        {
////            if( [(popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperName]) respondsToSelector:@selector(selectItemAtIndex:)] )
////            {
////                [popup selectItemAtIndex:-1];
////            }
////            if( [(popup = [[self panelView] viewWithTag:kTPPDEPopupTagPaperWidth]) respondsToSelector:@selector(selectItemAtIndex:)] )
////            {
////                [popup selectItemAtIndex:[self indexOfMenuItem:popup forValue:[choiceDict objectForKey:PPD_KEY_OPTION_WIDTH]]];
////            }
//        }
//        [[[self panelView] viewWithTag:kTPPDEPopupTagPaperName] setEnabled:(!isEnabled)];
//        [[[self panelView] viewWithTag:kTPPDEStepperTagOverspill] setEnabled:isEnabled];
//        [[[self panelView] viewWithTag:kTPPDEStepperTagOverspill | kTPPDEControlValueMask] setEnabled:isEnabled];
//        [[[self panelView] viewWithTag:kTPPDEPopupTagPaperWidth] setEnabled:isEnabled];
//        [[[self panelView] viewWithTag:kTPPDEMatrixTagSurface] setEnabled:isEnabled];
//        [self didSelectNewPaper:nil];
//        [self setDuplexAvailable];
//    }
//    else if([key isEqualToString:PPD_KEY_OPTION_TWO_SIDED])
//    {
//        [self updateControl:[[self panelView] viewWithTag:kTPPDEPopupTagTwoSided] withValue:choice];
//        [self setBindingMarginAvailable];
//    }
//    else if([key isEqualToString:PPD_KEY_OPTION_BINDMARGIN])
//    {
//        //[self updateControl:[[self panelView] viewWithTag:kTPPDEPopupTagBindingMargin] withValue:choice];
//        [self setBindingWidthAvailable];
//    }
//    else if([key isEqualToString:PPD_KEY_OPTION_WIDTH] || [key isEqualToString:PPD_KEY_OPTION_NAME] || [key isEqualToString:PPD_KEY_OPTION_SURFACE] )
//    {
//        [self didSelectNewPaper:nil];
//    }
//}
//- (NSString *) ppdChoiceForTag:(int)tag
//{
//	NSString *key=nil;
//	switch(tag)
//	{
//		case 1:
//			key = @"1";
//			break;
//		case 2:
//			key = @"2";
//			break;
//		case 3:
//			key = @"3";
//			break;
//		case 4:
//			key = @"4";
//			break;
//		case 5:
//			key = @"Real";
//			break;
//		case 6:
//			key = @"Resize";
//			break;
//		case 7:
//			key = @"Crop";
//			break;
//		default:
//			break;
//	}
//	return key;
//}
//- (NSInteger)tagForStringValue:(NSString *)string
//{
//	NSInteger tag=0;
//	if(string)
//	{
//		if([string isEqualToString:PPD_KEY_CHOICE_RESIZE_OVERALL])
//		{
//			tag = kTPPDEResizeTagOverall;
//		}
//		else if([string isEqualToString:PPD_KEY_CHOICE_RESIZE_CUT])
//		{
//			tag = kTPPDEResizeTagCut;
//		}
//		else if([string isEqualToString:PPD_KEY_CHOICE_RESIZE_REAL])
//		{
//			tag = kTPPDEResizeTagReal;
//		}
//		else if([string isEqualToString:@"1"])
//		{
//			tag = 1;
//		}
//		else if([string isEqualToString:@"2"])
//		{
//			tag = 2;
//		}
//		else if([string isEqualToString:@"3"])
//		{
//			tag = 3;
//		}
//		else if([string isEqualToString:@"4"])
//		{
//			tag = 4;
//		}
//	}
//	
//	return tag;
//}
//@end
