//
//  ATMPPR_PrintCoreDirect.h
//  dnp
//
//  Created by Atomic Pepper LLC on 12/16/12.
//
//

#import <Foundation/Foundation.h>
#import "ATMPPR_CUPSPrintJob.h"

@interface ATMPPR_PrintCoreDirect : NSObject
{
    ATMPPR_CUPSPrintJob *   _printJob;
    NSMutableDictionary *   _values;
    id                      _delegate;
    CFRunLoopRef            _runloop;
    NSThread *              _detachedThread;
    NSArray *               _imageFilters;
    NSData *                _commandData;
    NSString *              _debugLogFolder;
    NSUInteger              _imageCount;
    BOOL                    _canDuplex;
    BOOL                    _debugLog;
    BOOL                    _didSpool;
    NSUInteger              _totalImages;
    NSInteger               _lastReplyCode;
    BOOL                    _adjustmentsEnabled;
    BOOL                    _sharpnessEnabled;
    NSUInteger              _paperWidthActual;
    UInt16                  _paperLMin;
    UInt16                  _paperLMax;
    
}
@property (nonatomic, retain) ATMPPR_CUPSPrintJob *   printJob;
@property (nonatomic, retain) NSArray *               imageFilters;
@property (nonatomic, retain) NSMutableDictionary *   values;
@property (nonatomic, assign) id                    delegate;

-(id)initWithDeviceURI:(NSString *)deviceURI;

-(void)addImageFilter:(id)filter;
-(NSNumber *)correctedValue:(NSString *)val forType:(NSInteger)correctionType;

-(id)prepareForPrintJob;
-(BOOL)spoolOrder;
-(BOOL)sendImageData:(NSData *)imageData;

@end
