// $Id: rastertodnp.m -1   $
//
//  Created by tyler on 12/6/2012.
//  Copyright 2009 -2013 Atomic Pepper LLC. All rights reserved.
//
//  February 2009 -
//  Triprism Inc., is hereby granted a worldwide, perpetual, fully
//  paid license to use, modify, copy, compile and sublicense the
//  contents of this file.
//

#import "DNP_PrintUSB.h"
#import "ATMPPR_CUPSPrintJob.h"

// global variables
int gPidChild=0;    // global PID of child processs
int gSignal=0;      //global signal
const char * gDebugStr = "DEBUG";

#define SUPPORTS_DUPLEX     "--supportsDuplex"
#pragma mark -
int svn_rev();
char * svn_rev_str();

int main (int argc, const char * argv[])
{
    // always set up at least one autorelease pool
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    if (6 > argc || 7 < argc )
    {
        [[ATMPPR_CUPSPrintJob alloc] init];
    }
    
    [ATMPPR_CUPSPrintJob setShouldLogToStdErr:YES];
    db("^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^");
    db("starting up (v%s) on %@", svn_rev_str(), [ATMPPR_CUPSPrintJob systemVersionInfo]);

	int                     exitCode = 0;
    DNP_PrintUSB *    job = [[DNP_PrintUSB alloc] init];
    
    //db("standardUserDefaults %@",[[NSUserDefaults standardUserDefaults]dictionaryRepresentation]);
    //NSBundle * b = [NSBundle mainBundle];
    //db("AppleLanguages %@",[[NSUserDefaults standardUserDefaults] arrayForKey:@"AppleLanguages"]);
    //NSLocale * locale = [NSLocale currentLocale];
    //db("using language %@ in locale %@",[locale objectForKey:NSLocaleLanguageCode],[locale objectForKey:NSLocaleIdentifier]);
    //db("using bundle in %@", b );
    //db("%@", NSLocalizedString(@"test!",""));
    db("Language in %@", NSLocalizedString(@"test lang",""));

	db("Opening the CUPS Raster data stream");
    ATMPPR_CUPSPrintJob *  cupsPrintJob = [job prepareForPrintJob];
	if(nil == cupsPrintJob)
	{
		exitCode = 1;
		db("Failed to init CUPS! We are exiting abnormally here.");
        [ATMPPR_CUPSPrintJob fatal:NSLocalizedString(@"The printing system failed to initialize!","")];
	}
    else
    {
        // process the job data, page by page
        [cupsPrintJob processPageData];
        
        // send spool order for jobs that are not fast print
        if(NO == [job spoolOrder])
        {
            [cupsPrintJob fatal:NSLocalizedString(@"A problem prevented the order from spooling.","")];
            exitCode = 1;
        }
        
    }
    // Now we are done with this job

    db("finished with this job (%@ v%s)", [[NSProcessInfo processInfo] processName], svn_rev_str());
    db("vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv");

    [pool drain];

    return exitCode;
}
#pragma mark -

