#!/bin/bash
function die () {
	echo -e "failed at line number $@"
    rm -f "${LAUNCHD_TOKEN}"
	exit 1
}
convertHeaderToBash () {
exec 10<"${@}" || die $LINENO
local -i n=0;
local def key value extra

while read -u10 def key value extra;do
    if test -z "$extra" && test "$def" = '#define';then
        export ${key}=${value//\"/}
    fi
done
exec 10<&-
}

set -x
umask 0022
LAUNCHD_TOKEN=/private/var/tmp/dnpHappyBuildToken
PPD_ROOT=Library/Printers/PPDs/Contents/Resources
LIBEXEC_ROOT=usr/libexec
CUPS_FILTER_ROOT=cups/filter
CUPS_BACKEND_ROOT=usr/libexec/cups/backend
INSTALL_ROOT=install_root
BUNDLE_TEMPLATE=${PROJECT_DIR:=.}/bundleContents
PKGS_DIR=${PROJECT_DIR}/Packages
ICONS_ROOT=Icons
LAUNCH_DIR=Library/LaunchDaemons
BACKEND_DIR="${PROJECT_DIR}/backend"

touch "${LAUNCHD_TOKEN}" || die $LINENO

DEFS="${PROJECT_DIR}/ProjectDefines.txt"
SVN_VERSION_FILE="${PROJECT_DIR}/filter/svnversion.h"
test -r "${DEFS}" && . "${DEFS}" || die $LINENO
test -r "${SVN_VERSION_FILE}" && convertHeaderToBash "${SVN_VERSION_FILE}" || die $LINENO

svn up "${DEFS}" &&
 PKG_VERSION=($( svn info "${DEFS}"|awk '/^Revision:/ {print $NF;}')) || echo -e $LINENO "could not get svn info"
 PKG_VERSION=${SVN_VERSION_STR}

#BACKEND_BUILT_PATH="${BACKEND_DIR}/${BACKEND_BUILD_NAME}"
BACKEND_BUILT_PATH="${BUILT_PRODUCTS_DIR}/${BACKEND_BUILD_NAME}"
FILTER_BUILT_PATH="${BUILT_PRODUCTS_DIR}/${FILTER_BUILD_NAME}"
INSTALL_ROOT_DIR="${BUILD_DIR}/${INSTALL_ROOT}"
INSTALL_LAUNCH_DIR="${INSTALL_ROOT_DIR}/${LAUNCH_DIR}"
PPD_DIR="${INSTALL_ROOT_DIR}/${PPD_ROOT}"
BUNDLE_DIR="${INSTALL_ROOT_DIR}/${BUNDLE_ROOT}"
INSTALL_PDE_DIR="${BUNDLE_DIR}/${PDE_ROOT}"
CUPS_FILTER_DIR="${INSTALL_ROOT_DIR}/${LIBEXEC_ROOT}/${CUPS_FILTER_ROOT}"
CUPS_FILTER_DIR="${BUNDLE_DIR}/${CUPS_FILTER_ROOT}"
CUPS_BACKEND_DIR="${INSTALL_ROOT_DIR}/${CUPS_BACKEND_ROOT}"
ICONS_DIR="${BUNDLE_DIR}/${ICONS_ROOT}"
EXECUTABLE_PATH="${BUILT_PRODUCTS_DIR}/${EXECUTABLE_NAME:-${EXECUTABLE_BUILD_NAME}}"
SYS_CUPS_FILTER_DIR="/${BUNDLE_ROOT}/${CUPS_FILTER_ROOT}"
SYS_PDE_DIR="/${BUNDLE_ROOT}/${PDE_ROOT}"
SYS_PPD_DIR="/${PPD_ROOT}"

echo about to rm
sudo rm -rf "${INSTALL_ROOT_DIR}" || die $LINENO
sudo rm -rf "${CUPS_FILTER_DIR}" || die $LINENO
sudo rm -rf "${CUPS_BACKEND_DIR}" || die $LINENO
sudo rm -rf "${PPD_DIR}" || die $LINENO
sudo rm -rf "${ICONS_DIR}" || die $LINENO

mkdir -p "${CUPS_FILTER_DIR}" || die $LINENO
#mkdir -p "${CUPS_BACKEND_DIR}" || die $LINENO
mkdir -p "${PPD_DIR}"  || die $LINENO
mkdir -p "${ICONS_DIR}" || die $LINENO
mkdir -p "${PKGS_DIR}" || die $LINENO

#cTool="${PROJECT_DIR}/tools/CryptTool"
#test -x "${cTool}" || die $LINENO no cTool available
#cKey=75b7cfebbc8e16a19cc6382d40cce32a
#cOut=cryptData
#cIn="${PROJECT_DIR}/filter/rastertodnp"
#cDest="${TEMP_DIR}/rastertodnp"
#"${cTool}" e $cKey 128 "${cIn}" "${cOut}" a=a && cat "${EXECUTABLE_PATH}" "${cOut}" > "${cDest}" || die $LINENO "failed to cTool"
# future: attempt to make the merged product strip proof
#chmod a+x "${cDest}"
#&& cp "${cDest}"      /Library/Printers/Noritsu/NetOrder.bundle/Contents/cups/filter/rastertodnp
#$CP -p "${cDest}" "${CUPS_FILTER_DIR}/${EXECUTABLE_INSTALL_NAME}" || die $LINENO
#$CP -p "${cDest}" "${SYS_CUPS_FILTER_DIR}/${EXECUTABLE_INSTALL_NAME}" || die $LINENO

$CP -p "${FILTER_BUILT_PATH}" "${CUPS_FILTER_DIR}/${EXECUTABLE_INSTALL_NAME}" || die $LINENO

#rsync -rlE --no-implied-dirs --exclude=.svn/ "${LAUNCHD_AGENT}" "${INSTALL_LAUNCH_DIR}/" || die $LINENO

#cIn="${BACKEND_BUILT_PATH}"
#cDest="${TEMP_DIR}/${BACKEND_BUILD_NAME}"
#
#"${cTool}" e $cKey 128 "${cIn}" "${cOut}" a=a && cat "${EXECUTABLE_PATH}" "${cOut}" > "${cDest}" || die $LINENO "failed to cTool"
#rm -f "${cOut}"
## future: attempt to make the merged product strip proof
#chmod a+x "${cDest}"
#
#$CP -p "${cDest}" "${CUPS_BACKEND_DIR}/" || die $LINENO

#$CP -p "${BACKEND_BUILT_PATH}" "${CUPS_BACKEND_DIR}/" || die $LINENO
oIFS="$IFS"
IFS=$'\n'
PPD_PATHS=($(find "${PROJECT_DIR:=./build}/build/PPD" -name '*.ppd'))
IFS="${oIFS}"
$CP -R "${PPD_PATHS[@]}" "${PPD_DIR}/" || die $LINENO
/usr/bin/find "${PPD_DIR}" -name '*.ppd' -exec /usr/bin/gzip '{}' ';'

/usr/bin/find  "${INSTALL_ROOT_DIR}" -name .svn -o -name .DS_Store -o -name '._*' -exec rm -rf '{}' ';'

rsync -rlE --no-implied-dirs --exclude=.svn/  "${BUNDLE_TEMPLATE}/" "${BUNDLE_DIR}/" || die $LINENO


#PROJECT_ROOT=$(dirname ${PROJECT_DIR:-/})
PROJECT_ROOT="${PROJECT_DIR}"
test -d "${INSTALL_ROOT_DIR}" || die $LINENO

PKG_PATH="${PKGS_DIR}/${PKG_TITLE}.pkg"

echo -e "${INSTALL_ROOT_DIR}" || die $LINENO
rm -rf "${INSTALL_PDE_DIR}"                || die $LINENO
mkdir -p "${INSTALL_PDE_DIR}"                || die $LINENO


EXECUTABLE_PATH="${BUILT_PRODUCTS_DIR}/${PDE_EXECUTABLE_NAME}"

$CP -R "${EXECUTABLE_PATH}" "${INSTALL_PDE_DIR}/"		&&

if sudo mkdir -p "${SYS_PDE_DIR}" ;then
 sudo mkdir -p "${SYS_CUPS_FILTER_DIR}" || die $LINENO
 sudo $CP  "${FILTER_BUILT_PATH}" "${SYS_CUPS_FILTER_DIR}/${EXECUTABLE_INSTALL_NAME}" || die $LINENO

sudo mkdir -p "${SYS_PPD_DIR}" || die $LINENO
sudo $CP -R "${PPD_DIR}/"* "${SYS_PPD_DIR}/" || die $LINENO

sudo mkdir -p "${SYS_PDE_DIR}"                || die $LINENO
sudo $CP -R "${EXECUTABLE_PATH}" "/${SYS_PDE_DIR}/"		|| die $LINENO
sudo rm -f "${LAUNCHD_TOKEN}"
else

 TXT_TMP_DIR=$(mktemp -d "${TMPDIR:=/tmp}/XXXXXXXXXXXXX")
 if test -w "${TXT_TMP_DIR}";then
  TXT_TMP_MEMO="${TXT_TMP_DIR}/Xcode Build Notice.rtf"
  echo '{\rtf1\ansi\ansicpg1252\cocoartf1038\cocoasubrtf110{\fonttbl\f0\fswiss\fcharset0 Helvetica;}{\colortbl;\red255\green255\blue255;}\margl1440\margr1440\vieww18480\viewh2260\viewkind0\pard\tx560\tx1120\tx1680\tx2240\tx2800\tx3360\tx3920\tx4480\tx5040\tx5600\tx6160\tx6720\ql\qnatural\pardirnatural\f0\fs68 \cf0 Auto-install not possible. Please run the installer manually.}' > "${TXT_TMP_MEMO}" &&
  open "${TXT_TMP_MEMO}" && sleep 2
  rm -rf "${TXT_TMP_DIR}"
 fi
fi


pushd "${INSTALL_PDE_DIR}/${PDE_EXECUTABLE_NAME}/Contents/Resources" && {
pwd
 ln -sfhv English.lproj/Localizable.strings en-US.strings
 ln -sfhv English.lproj/Localizable.strings en.strings
 ln -sfhv French.lproj/Localizable.strings fr.strings
 ln -sfhv Japanese.lproj/Localizable.strings ja.strings
 ln -sfhv German.lproj/Localizable.strings de.strings
 popd
}
rm -rf "${PKG_PATH}"
T_SCRIPTS_DIR="${TEMP_DIR}/installer_scripts"
EN_LPROJ="${PROJECT_DIR}/scripts/installer_resources"
rsync -rlE --no-implied-dirs  --delete  --exclude=.svn/ "${INSTALLER_SCRIPTS_DIR}/" "${T_SCRIPTS_DIR}/"



/usr/bin/find  "${INSTALL_ROOT_DIR}" -type d -exec chmod 755 '{}' ';'
/usr/bin/find  "${INSTALL_ROOT_DIR}/Library" -type d -exec chmod 755 '{}' ';'
chmod -R o-w "${INSTALL_ROOT_DIR}"

#sudo chmod -R 755 "${INSTALL_ROOT_DIR}"    || die $LINENO
sudo chmod 1755 "${INSTALL_ROOT_DIR}"    || die $LINENO
sudo chmod 1755 "${INSTALL_ROOT_DIR}/Library"    || die $LINENO

sudo chown -R 0:80 "${INSTALL_ROOT_DIR}" || die $LINENO

#sudo chown -R 0:0 "${INSTALL_ROOT_DIR}/usr" || die $LINENO
#sudo chmod -R 755 "${INSTALL_ROOT_DIR}/usr" || die $LINENO
#sudo chmod -R 755 "${CUPS_BACKEND_DIR}" || die $LINENO

sudo chown  0:80 "${CUPS_FILTER_DIR}/${EXECUTABLE_INSTALL_NAME}" || die $LINENO
sudo chmod 755 "${CUPS_FILTER_DIR}/${EXECUTABLE_INSTALL_NAME}" || die $LINENO

PACKAGEMAKER_APP_PATH="/Applications/Utilities/PackageMaker.app/Contents/MacOS/PackageMaker"

test -x "${PACKAGEMAKER_APP_PATH}" || PACKAGEMAKER_APP_PATH="/Developer${PACKAGEMAKER_APP_PATH}"

test -x "${PACKAGEMAKER_APP_PATH}" || die $LINENO

"${PACKAGEMAKER_APP_PATH}"  --verbose\
                            --root "${INSTALL_ROOT_DIR:-ERROR}"\
                            --no-recommend\
                            --root-volume-only\
                            --id "${PKG_ID:-ERROR}"\
                            --filter /\._.DS_Store$\
                            --filter /\.DS_Store$\
                            --filter /\.svn$\
                            --title "${PKG_TITLE:-ERROR}"\
                            --version ${PKG_VERSION:-001}\
                            --out "${PKG_PATH:-ERROR}"\
                            --resources "${EN_LPROJ:-ERROR}"\
                            --scripts "${T_SCRIPTS_DIR}"\
        || die $LINENO 
#                            --doc "${PACKAGE_MAKER_FILE}"\
#                            --target 10.4\
#                            --target 10.5\
        
# fix auth for steve
infoFile="${PKG_PATH}/Contents/Info.plist"
mv "${infoFile}" "${infoFile}.in" &&
awk '/IFPkgFlagAuthorizationAction/ {print $0;getline;sub("[^>]+Authorization","RootAuthorization");print $0;dict["IFPkgFlagBackgroundScaling"]="none";dict["IFPkgFlagBackgroundAlignment"]="bottomleft";for(key in dict){printf "\t<key>%s</key>\n\t<string>%s</string>\n",key,dict[key]} next};{print $0;}' "${infoFile}.in" > "${infoFile}" &&
rm "${infoFile}.in" || die $LINENO
PKG_PARENT_DIR="$(/usr/bin/dirname "${PKG_PATH}")"

#run postflight to update PPDs
"${INSTALLER_SCRIPTS_DIR}/postflight" || die $LINENO

#tar -C "${PKG_PARENT_DIR}" -cjf "${PKG_PATH%.pkg}-v${PKG_VERSION}.tar.bz2" "${PKG_TITLE}.pkg"
pushd "${PKG_PARENT_DIR}" && /usr/bin/zip -r "${PKG_TITLE}-v${PKG_VERSION}.zip" "${PKG_TITLE}.pkg" && popd

open "${PKG_PATH}"

rm -f "${LAUNCHD_TOKEN}"

